// #autoload
// #name = ObserverHUD
// #version = 1.6.3
// #date = June 15, 2001
// #author = Daniel Neilsen (aka Wizard_TPG)
// #warrior = Wizard
// #email = bugs@bugssite.org - email me here for any fixes or bug reports -- ^BuGs^
// #description = ObserverHUD is a HUD that only appears whilst in observer mode.
// #status = pre-release 3
// #include = autoload 2.2.1
// #include = support/map.cs 1.0.9
// #include = support/events.cs 1.0.4
// #include = support/callback.cs
// #include = support/file_tools.cs
// #include = support/player_support.cs
// #include = support/flag_tracker.cs
// #include = support/stat_support.cs
// #include = support/docking_tools.cs
// #include = support/kill_callbacks.cs
// #include = support/mission_callbacks.cs
// #include = support/PJColorSelector.cs
// #credit = More than one person helped. Check the readme file for a full list
// #credit = Fixed by ^BuGs^ & Kesh! & Katien
// #credit = MAJOR Help/Code by: Katien
// #credit = Help/Code by: Mental Trousers
// #credit = V-z0dd & ZOD - Classic 1.4.1
// #credit = Uberguy - Flag Track Code Fix
// #credit = LouCypher - being a pain & testing it (<3)
// #credit = ^|Platinum|^ - pain also.. :)
// #credit = Rapture & ATF Servers
// #credit = That one guy who always wanted to get in the server and play...
// #credit = #t2scripters, #rapture, #wsbn, and #tsn
// #config = ObserverHUDGUI
// #readme = wizard/observerhud.txt
// ---------------------------------------------------------------------------

exec("prefs/ObserverHUDPrefs.cs");
if(!isfile("prefs/ObserverHUDPrefs.cs"))
{
	if ($ObserverHUDVersion $= ObserverHUD.version)
	{ 
		ObserverHUD.CreateSettings();
		$ObserverHUDVersion = ObserverHUD.version;
	}
}

if(!isObject(ObserverHUD))
{
    new ScriptObject(ObserverHUD)
    {
        class = ObserverHUD;
        ClientDisconnect = false;
        DisallowMissionNameReset = true;
	version = "1.6.3";
	KillColor = $ObserverHUDSettings::KillColor;
	DeathColor = $ObserverHUDSettings::DeathColor;
	InfoColor = $ObserverHUDSettings::InfoColor;
	StatColor = $ObserverHUDSettings::StatColor;
	TitleColor = $ObserverHUDSettings::TitleColor;
    };
}

//======================================================================
// Files to exec on load

exec("wizard/observerhud_css.cs");
exec("wizard/observerhud_gui.cs");
exec("wizard/observerhud_hud.cs");
exec("wizard/observerhud_html.cs");

//==================================================================
//Start and End mission code

function handleObserverHUDMissionStart (%msgType, %msgString)
{
	if(strstr(%msgString, "Match started!") == -1)
		return;

	//Stat cleanup on mission start if not already cleaned up
	ObserverHUD.StatReset();
	ObserverHUD.StatsReset = false;
	ObserverHUDMissionData.MissionEnd = false;
	ObserverHUD.MissionEndCodeExec = false;

	//Reset GameClock Compared to getSimTime
	ObserverHUD.getSimTimeAtStart = mfloor(getSimTime()/1000);
	ObserverHUD.getGameTimeAtStart = 0;
}

function ObserverHUD::MissionEnd (%this)
{
	ObserverHUD.ClientDisconnect = false;
	ObserverHUDMissionData.MissionEnd = true;

	//finalise team times
	%i = 0;
	%p = PlayerList.findByIndex(%i);
	while (%p !$= $PLAYER_ERROR)
	{
		ObserverHUD.UpdateClientTeamTimes(%p.name);
		%i++;
		%p = PlayerList.findByIndex(%i);
	}
	ObserverHUD.ObserverHUDStatCleanup();
}

function handleObserverHUDMissionEnd (%msgType, %msgString, %seconds)
{
	if(%seconds !$= "")
		return;
	ObserverHUD.MissionEndCodeExec = true;
	ObserverHUD.MissionEnd();
}

function handleObserverHUDMissionEndBackup(%msgType, %msgString)
{
	if(ObserverHUD.MissionEndCodeExec)
		return;
	ObserverHUD.MissionEnd();
}

function ObserverHUD::ObserverHUDStatCleanup(%this)
{
	if($ObserverHUDSettings::AutoStatsOutput)
	{
		ObserverHUD.OutputStats(true);
	}
	else if($ObserverHUDSettings::PromptStatsOutput)
	{
		messageBoxOkCancel("ObserverHUD Stats", "Do you wish to output this maps stats to the file in /base/ObserverHUD/ ?", "ObserverHUDOutputStats(true);", "ObserverHUDStatReset();");
	}
	else
	{
		ObserverHUDStatReset();
	}
}

function ObserverHUD::StatReset(%this)
{
	if(ObserverHUD.StatsReset)
		return;

	ObserverHUD.StatsReset = true;
	%missionname = ObserverHUDMissionData.MissionName;
	%missiontype = ObserverHUDMissionData.MissionType;

	if(isObject(ObserverHUDMissionData))
	{
		ObserverHUDMissionData.delete();
	}
	if(%this.ClientDisconnect)
	{
		if(isObject(ObserverHUDServerData))
		{
			ObserverHUDServerData.delete();
		}
	}
	else
	{
		new ScriptObject(ObserverHUDMissionData)
		{
			class = ObserverHUDMissionData;
		};
	}
	if(ObserverHUD.DisallowMissionNameReset)
	{
		ObserverHUDMissionData.MissionName = %missionname;
		ObserverHUDMissionData.MissionType = %missiontype;
		ObserverHUD.DisallowMissionNameReset = false;
	}
	
	for (%e=1; %e<=ObserverHUDWeaponArrayname.count; %e++)
	{
		%trackerreset = "WeaponArrayKillsDeaths[" @ ObserverHUDWeaponArrayname.name[%e] @ "]";
		for (%h=1; %h<=ObserverHUDWeaponArray.count; %h++)
		{
			%weapon = ObserverHUDWeaponArray.weapon[%h];
			%trackerreset.kills[%weapon] = 0;
			%trackerreset.deaths[%weapon] = 0;
		}
		
	}
	
	deletevariables("$ObserverHUDHTML::*");
	echo("ObserverHUD: Stat Cleanup Complete");
	ObserverHUD.Update();
}

function ObserverHUDStatReset()
{
	//Dont do this yet....wait for mission start.
	//ObserverHUD.StatReset();
}

//================================================================
// Startup Code - Run this stuff on server connection

function handleObserverHUDClientJoined (%msgType, %msgString, %clientName, %clientid)
{
    if (strstr(%msgString, "Welcome to Tribes2") == -1)
    	return;

    ObserverHUDMissionData.MissionEnd = false;
    ObserverHUD.ObserverHUDGetScores();

	//Reset getSimTime in relation to game time
	ObserverHUD.getSimTimeAtStart = mfloor(getsimtime()/1000);
	ObserverHUD.getGameTimeAtStart = ObserverHUDMissionData.MissionTime;


	if(!isObject(ObserverHUDMissionData))
	{
		new ScriptObject(ObserverHUDMissionData)
		{
			class = ObserverHUDMissionData;
		};
	}
	if(!isObject(ObserverHUDServerData))
	{
		new ScriptObject(ObserverHUDServerData)
		{
			class = ObserverHUDServerData;
		};
	}

}

function StripNameColors(%in)
{

	%name = "";

	for (%i = 0; %i < Strlen(%in); %i++)
	{
		%ascii = String::ascii(%in, %i);
		if ((%ascii > 31) && (%ascii < 129))
			%name = %name @ String::char(%ascii);
	}

	%name = %name @ "";
	return %name;
}

function String::ascii(%string, %idx)
{

	if(Strlen(%string) <= %idx || %idx < 0)
	    return -1;
	%char = getSubStr(%string, %idx, 1);
	%idx = Strstr($String::asciiString, %char);
	if(%idx < 0)
		return -1;

	if(Strcmp(%char, getSubStr($String::asciiString, %idx, 1)) == 0)
		return %idx + 32;
    else
        return %idx + 64;
}

function String::char(%ascii)
{
	if(%ascii < 32 || %ascii > 128)
		return "";
	else
		return getSubStr($String::asciiString, %ascii-32, 1);
}

$String::asciiString = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";


//==================================================================
//Get system timer

function handleObserverHUDTimer(%msgType, %msgString, %timelimit, %curTimeLeftMS)
{
	if(%timelimit > 1)
		ObserverHUDMissionData.TimeLimit = %timelimit;

	if(ObserverHUDMissionData.MissionEnd)
		return;
	%starttime = (%timelimit * 60)*1000;
	if(%curTimeLeftMS <= 10000)
		%temptime = %starttime/1000;
	else
		%temptime = (%starttime - %curTimeLeftMS)/1000;
	ObserverHUDMissionData.MissionTime = %temptime >= 0 ? %temptime : ObserverHUDMissionData.MissionTime;
}


function ObserverHUD::UpdateGameTimer(%this)
{
	if(ObserverHUD.getGameTimeAtStart)
		%simTimeExtra = ObserverHUD.getGameTimeAtStart;
	else
		%simTimeExtra = ObserverHUD.getGameTimeAtStart-ObserverHUD.getSimTimeAtStart;
	%currentSimTime	= mfloor(getSimTime()/1000);
	%newtime = %currentSimTime + %simTimeExtra;
	ObserverHUDMissionData.MissionTime = %newtime;
}

//==================================================================
//Get server info

function handleObserverHUDMissionInfo(%msgType, %msgString, %missionname, %missiontype, %servername)
{
	if(!isObject(ObserverHUDMissionData))
	{
		new ScriptObject(ObserverHUDMissionData)
		{
			class = ObserverHUDMissionData;
		};
	}
	if(!isObject(ObserverHUDServerData))
	{
		new ScriptObject(ObserverHUDServerData)
		{
			class = ObserverHUDServerData;
		};
	}
	ObserverHUD.DisallowMissionNameReset = true;
	ObserverHUDMissionData.MissionName = %missionname;
	ObserverHUDMissionData.MissionType = %missiontype;
	ObserverHUDServerData.ServerName = %servername;
	ObserverHUDServerData.ServerAddress = getRecord( $ServerInfo, 1 );
	ObserverHUDServerData.ServerMod = getRecord( $ServerInfo, 2 );
	ObserverHUDServerData.ServerType = getRecord( $ServerInfo, 3 );
}

//==================================================================
//Get client times

function getPlayerTeamTime()
{
	%name = %this.CurrentName;
	%oldteam = ObserverHUDMissionData.ClientPreviousTeam[%name];
	error("teamtime for ",%name," = ",ObserverHUDMissionData.ClientTeamTime[%name, %oldteam]);
}

function ObserverHUD::UpdateClientTeamTimes(%this, %name)
{
	if(PlayerList.getTeamByName(%name) $= "")
		return;

	if(%name $= "")
		return;

	%oldteam = ObserverHUDMissionData.ClientPreviousTeam[%name];
	if(%oldteam $= "")
	{
		ObserverHUDMissionData.ClientStartTime[%name] = $ObserverHUD::MissionTime;
	}
	else
	{
		ObserverHUDMissionData.ClientTeamTime[%name, %oldteam] += (ObserverHUDMissionData.MissionTime - ObserverHUDMissionData.ClientStartTime[%name]);
		ObserverHUDMissionData.ClientStartTime[%name] = ObserverHUDMissionData.MissionTime;
	}
	ObserverHUDMissionData.ClientPreviousTeam[%name] = PlayerList.getTeamByName(%name);
	return;
}


//==================================================================
//Get client info on team change

function handleObserverHUDClientInfo (%msgType, %msgString, %clientName, %teamname, %clientId, %teamid)
{
	%detaggedname = detag(%clientName);

	//Fix mission names if data lost.
	if(ObserverHUDMissionData.MissionName !$= $clMissionName)
	{
		ObserverHUDMissionData.MissionName = $clMissionName;
		ObserverHUDMissionData.MissionType = $clMissionType;
	}

	//calculate time
	ObserverHUD.UpdateClientTeamTimes(%detaggedname);

	//create and destroy hud on team change
	if(%clientId == PlayerList.getMyID())
	{
		ObserverHUD.ObserverHUDGetScores();
		if(%teamid == 0)
		{
			//display observerHUD
			if(ObserverHUDMissionData.TeamIDtoName[1] $= "") { ObserverHUDMissionData.TeamIDtoName[1] = objectiveHud.teamName[1].getValue(); } 
			if(ObserverHUDMissionData.TeamIDtoName[2] $= "") { ObserverHUDMissionData.TeamIDtoName[2] = objectiveHud.teamName[2].getValue(); } 
			ObserverHUD.Create();
		}
		else
		{
			//hide observerHUD
			ObserverHUD.Destroy();
		}
	}

	//save team info
	%detaggedteamname = detag(%teamname);
	ObserverHUDMissionData.TeamNametoID[%detaggedteamname] = %teamid;
	ObserverHUDMissionData.TeamIDtoName[%teamid] = %detaggedteamname;

	//Check team min/max players
	ObserverHUDMissionData.TeamPlayers[0] = 0;
	ObserverHUDMissionData.TeamPlayers[1] = 0;
	ObserverHUDMissionData.TeamPlayers[2] = 0;
	%i = 0;
	%p = PlayerList.findByIndex(%i);
	while (%p !$= $PLAYER_ERROR)
	{
		ObserverHUDMissionData.TeamPlayers[%p.teamID]++;
		%i++;
		%p = PlayerList.findByIndex(%i);
	}
	for(%team = 1; %team < 3; %team++)
	{
		ObserverHUDMissionData.MaxTeamPlayers[%team] = ObserverHUDMissionData.MaxTeamPlayers[%team] < ObserverHUDMissionData.TeamPlayers[%team] ? ObserverHUDMissionData.TeamPlayers[%team] : ObserverHUDMissionData.MaxTeamPlayers[%team];
		ObserverHUDMissionData.MinTeamPlayers[%team] = ObserverHUDMissionData.MinTeamPlayers[%team] > ObserverHUDMissionData.TeamPlayers[%team] ? ObserverHUDMissionData.TeamPlayers[%team] : ObserverHUDMissionData.MinTeamPlayers[%team];
	}
}

//==================================================================
//Get client ping and PL

function ObserverHUD::ObserverHUDCalculatePing(%this)
{
	%i = 0;
	%p = PlayerList.findByIndex(%i);
	while (%p !$= $PLAYER_ERROR)
	{
		%name = %p.name;
		ObserverHUDMissionData.ClientPing[%name] = %p.ping;
		ObserverHUDMissionData.ClientPL[%name] = %p.packetloss;
		ObserverHUDMissionData.ClientPingTotal[%name] += %p.ping;
		ObserverHUDMissionData.ClientPLTotal[%name] += %p.packetloss;
		if(%p.ping != 0 && %p.ping !$= "")
			ObserverHUDMissionData.ClientPingTest[%name]++;
		%i++;
		%p = PlayerList.findByIndex(%i);
		if (isObject(ObserverHUDPlayerDetail))
		{
			ObserverHUD.Update();
		}
	}
}

function ObserverHUD::ObserverHUDGetScores(%this)
{
	if(%this.pingcheck)
	{
		cancel(%this.pingcheck);
		%this.pingcheck = 0;
	}
	%this.ObserverHUDCalculatePing();

	//Outut timer code check
	$ObserverHUDSettings::OutputTimerCounter++;
	if($ObserverHUDSettings::OutputTimer > 0 && !ObserverHUDMissionData.MissionEnd)
	{
		if($ObserverHUDSettings::OutputTimerCounter >= $ObserverHUDSettings::OutputTimer)
		{
			$ObserverHUDSettings::OutputTimerCounter = 0;
			%this.OutputStats(false);
		}
	}


	$ObserverHUDSettings::PingCheckTimer++;
	if($ObserverHUDSettings::PingCheck && $ObserverHUDSettings::PingCheckTimer >= 10)
	{
		$ObserverHUDSettings::PingCheckTimer = 0;
		commandToServer( 'getScores' );
	}
	%this.pingcheck = %this.schedule(1000,"ObserverHUDGetScores");
}


//==================================================================
//Get team scores

function handleObserverHUDTeamScore (%msgType, %msgString, %teamid, %teamscore)
{
	ObserverHUDMissionData.TeamScore[%teamid] = %teamscore;
	ObserverHUD.Update();
}

//==================================================================
//Get client kills/deaths

function ObsHUDTurretKillTypes(%type)
{
 	$ObserverHUD::TurretKillTypes[0] = "msgTurretKill";
 	$ObserverHUD::TurretKillTypes[1] = "msgCTurretKill";
 	$ObserverHUD::TurretKillTypes[2] = "msgTurretSelfKill";
	for (%i = 0; %i < 4; %i++)
	{
		if (%i $= 3) { return false; }
		if (%type $= $ObserverHUD::TurretKillTypes[%i])
		{
			return true;
		}
	}
}

function ObsHUDNonKillerDeaths(%type)
{
	$ObserverHUD::DeathKillTypes[0] = "ground";
	$ObserverHUD::DeathKillTypes[2] = "lava";
	$ObserverHUD::DeathKillTypes[3] = "explosion";
	$ObserverHUD::DeathKillTypes[4] = "impact";
	for (%i = 0; %i < 6; %i++)
	{
		if (%i $= 5) { return false; }
		if (%type $= $ObserverHUD::DeathKillTypes[%i])
		{
			return true;
		}
	}
	
}


//function handleObserverHUDKillInfo (%msgType, %msgString, %victimname, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, %weaponName)
function ObserverHUD::onKill(%this, %type, %killerRef, %victimRef, %weapon, %i_die, %i_win, %suicide, %tk)
{
	if (MissionCallback.getMissionType() $= "Deathmatch") { return false; }
	
	%vName = detag(%victimRef.name);
	%vTeam = PlayerList.getTeamByName(%vName);
	
	if (%killerRef.name $= "")
	{
		%kTeam = %vTeam == 1 ? 2 : 1;
		%isTurret = ObsHUDTurretKillTypes(%type);
		if(%isTurret $= 1)
		{
			ObserverHUD.addUserArray(%vName);
			ObserverHUD.addWeapontoMapKillArray(%weapon);
			ObserverHUD.createTrackerInfo(%vName, false, true, %weapon);
			
			ObserverHUDMissionData.TeamTurretKill[%kTeam]++;
			ObserverHUDMissionData.TeamTurretDeath[%vTeam]++;
			ObserverHUDMissionData.ClientTurretDeath[%vName]++;
			ObserverHUDMissionData.ClientDeathBy[%vName] = %weapon;	
		}
		else if(%weapon $= "suicide")
		{
			ObserverHUDMissionData.TeamSuicide[%vTeam]++;
			ObserverHUDMissionData.ClientSuicide[%vName]++;
			ObserverHUDMissionData.ClientDeathBy[%vName] = "Suicide";
		}
		else
		{
			ObserverHUD.addUserArray(%vName);
			%isKilledby = ObsHUDNonKillerDeaths(%weapon);
			if (%isKilledby == false)
			{
				ObserverHUD.addWeapontoMapKillArray(%weapon);
				ObserverHUD.createTrackerInfo(%vName, false, true, %weapon);
			}
			
			ObserverHUDMissionData.TeamOtherDeath[%vTeam]++;
			ObserverHUDMissionData.ClientDeath[%vName]++;
			ObserverHUDMissionData.ClientDeathBy[%vName] = %weapon;	
		}
		ObserverHUD.Update();
		return;
	}
	
	%kName = detag(%killerRef.name);
	%kTeam = PlayerList.getTeamByName(%kName);
	
	if(%suicide && (%kName $= %vName))
	{
		ObserverHUDMissionData.TeamSuicide[%vTeam]++;
		ObserverHUDMissionData.ClientSuicide[%vName]++;
		ObserverHUDMissionData.ClientDeathBy[%vName] = "Suicide";
	}
	else if(%tk && (%kTeam $= %vTeam))
	{
		ObserverHUD.addUserArray(%kName);
		ObserverHUD.addUserArray(%vName);
		ObserverHUD.addWeapontoMapKillArray(%weapon);
		ObserverHUD.createTrackerInfo(%kName, true, false, %weapon);
		ObserverHUD.createTrackerInfo(%vName, false, true, %weapon);
		
		ObserverHUDMissionData.TeamTeamKill[%kTeam]++;
		ObserverHUDMissionData.ClientTeamKill[%kName]++;
		ObserverHUDMissionData.ClientDeath[%vName]++;
		ObserverHUDMissionData.ClientDeathBy[%vName] = "TK-" @ %kName;
	}
	else if(%weapon $= "suicide")
	{
		ObserverHUDMissionData.TeamSuicide[%vTeam]++;
		ObserverHUDMissionData.ClientSuicide[%vName]++;
		ObserverHUDMissionData.ClientDeathBy[%vName] = "Suicide";
	}
	else 
	{
		ObserverHUD.addUserArray(%kName);
		ObserverHUD.addUserArray(%vName);
		ObserverHUD.addWeapontoMapKillArray(%weapon);
		ObserverHUD.createTrackerInfo(%kName, true, false, %weapon);
		ObserverHUD.createTrackerInfo(%vName, false, true, %weapon);
		
		ObserverHUDMissionData.TeamKill[%kTeam]++;
		ObserverHUDMissionData.TeamDeath[%vTeam]++;
		ObserverHUDMissionData.ClientKill[%kName]++;
		ObserverHUDMissionData.ClientDeath[%vName]++;
		ObserverHUDMissionData.ClientDeathBy[%vName] = %kName;
	}

	ObserverHUD.Update();
	return;
}

function ObserverHUD::addWeapontoMapKillArray(%this, %weapon)
{
	if (%weapon $= "")
	{ 
		warn("addding weapon to array can not happen -- %weapon is empty"); 
	} else {
		$ObsWeapontoMapKillArray::Exists = false;
		for (%i = 1; %i <= ObserverHUDWeaponArray.count; %i++)
		{
			if (ObserverHUDWeaponArray.weapon[%i] $= %weapon)
			{
				$ObsWeapontoMapKillArray::Exists = true;
			}
		}
		if (!$ObsWeapontoMapKillArray::Exists)
		{
			ObserverHUDWeaponArray.count++;
			ObserverHUDWeaponArray.weapon[ObserverHUDWeaponArray.count] = %weapon;
		}
	}
}

function ObserverHUD::arrayWeaponNum(%this, %weapon)
{
	for (%i = 1; %i <= ObserverHUDWeaponArray.count; %i++)
	{
		if (ObserverHUDWeaponArray.weapon[%i] $= %weapon)
		{
			return %i;
		}
	}
}

function ObserverHUD::addUserArray(%this, %name)
{
	if (%name $= "")
	{ 
		warn("addding name to array can not happen -- %name is empty"); 
	} else {
		$ObsWeapontoMapNameArray::Exists = false;
		for (%i = 1; %i <= ObserverHUDWeaponArrayName.count; %i++)
		{
			if (ObserverHUDWeaponArrayName.name[%i] $= %name)
			{
				$ObsWeapontoMapNameArray::Exists = true;
			}
		}
		if (!$ObsWeapontoMapNameArray::Exists)
		{
			ObserverHUDWeaponArrayName.count++;
			ObserverHUDWeaponArrayName.name[ObserverHUDWeaponArrayName.count] = %name;
		}
	}
}

function ObserverHUD::arrayNameNum(%this, %name)
{
	for (%i = 1; %i <= ObserverHUDWeaponArrayName.count; %i++)
	{
		if (ObserverHUDWeaponArrayName.name[%i] $= %name)
		{
			return %i;
		}
	}
}

function ObserverHUD::createTrackerInfo(%this, %name, %killer, %victim, %weapon) {
	if ((%weapon $= "") && (%name $= "") && (%killer $= "") && (%victim $= ""))
	{ 
		warn("creating track record did not work cause one or more vars were not set"); 
	} else {
		if (!isObject("WeaponArrayKillsDeaths[" @ %name @ "]"))
		{
			new ScriptObject("WeaponArrayKillsDeaths[" @ %name @ "]") {
				kills = Container::newVectorMap();
				deaths = Container::newVectorMap();
			};
			%tracker = "WeaponArrayKillsDeaths[" @ %name @ "]";
			if (%killer)
			{
				%tracker.kills[%weapon] = 1;
				%tracker.deaths[%weapon] = 0;
			}
			if (%victim)
			{
				%tracker.kills[%weapon] = 0;
				%tracker.deaths[%weapon] = 1;
			}
		} else {
			%tracker = "WeaponArrayKillsDeaths[" @ %name @ "]";
			if (%killer)
			{
				%tracker.kills[%weapon]++;
			}
			if (%victim)
			{
				%tracker.deaths[%weapon]++;
			}
		}
	}
}

// new scripts object to track weapons kill/deaths for each player
// this is how many weapons are recored into the Weapon Array
if (!isObject("ObserverHUDWeaponArray"))
{
	new ScriptObject("ObserverHUDWeaponArray") {
		count = 0;
		weapon = Container::newVectorMap();
	};
}

if (!isObject("ObserverHUDWeaponArrayName"))
{
	new ScriptObject("ObserverHUDWeaponArrayName") {
		count = 0;
		name = Container::newVectorMap();
	};
}

//==================================================================
//Client Drop Code

function handleObserverHUDClientDrop (%msgType, %msgString, %clientname, %clientid)
{
	for(%i=0; %i<10; %i++)
	{
		if(ObserverHUD.QuickListPlayer[%i] $= %clientid)
		{
			ObserverHUD.QuickListPlayer[%i] = 0;
		}
	}
	ObserverHUD.Update();
}

//==================================================================
//==================================================================
//
//                         GAME CODE
//
//==================================================================
//==================================================================
//==================================================================

//------------------------------------------------------------------
//	CTF Specific Stuff

function handleObserverHUDCTFTeamInfo (%msgType, %msgString, %teamid, %teamname, %flagstatus, %teamscore)
{
	ObserverHUDMissionData.TeamScore[%teamid] = %teamscore;
	ObserverHUDMissionData.GameType = "CTF";
	ObserverHUD.Update();
}

function handleObserverHUDCTFFlagTaken (%msgType, %msgString, %clientname, %flagteamname, %flagteamid, %namebase)
{
	%name = detag(%clientname);
	ObserverHUDMissionData.ClientFlagGrab[%name]++;
	%capperteam = PlayerList.getTeamByName(%name);
	ObserverHUDMissionData.TeamFlagGrab[%capperteam]++;
	ObserverHUDMissionData.GameType = "CTF";
	$ObserverHUDFlagStatus[%flagteamid] = %name;
	ObserverHUDMissionData.FlagStatus[%flagteamid] = %name;
	ObserverHUD.AutoView(%flagteamid);
	ObserverHUD.Update();
}

function handleObserverHUDCTFFlagDropped (%msgType, %msgString, %clientname, %flagteamname, %flagteamid)
{
	%name = detag(%clientname);
	ObserverHUDMissionData.ClientFlagDrop[%name]++;
	%capperteam = PlayerList.getTeamByName(%name);
	ObserverHUDMissionData.TeamFlagDrop[%capperteam]++;
	ObserverHUDMissionData.GameType = "CTF";
	$ObserverHUDFlagStatus[%flagteamid] = "In the field";
	ObserverHUDMissionData.FlagStatus[%flagteamid] = "";
	ObserverHUD.Update();
}

function handleObserverHUDCTFFlagCapped (%msgType, %msgString, %clientname, %flagteamname, %flagteamid, %clientteamid)
{
	%name = detag(%clientname);
	ObserverHUDMissionData.ClientFlagCap[%name]++;
	ObserverHUDMissionData.TeamFlagCap[%clientteamid]++;
	ObserverHUDMissionData.GameType = "CTF";
	$ObserverHUDFlagStatus[%flagteamid] = "At" SPC $clTeamScore[%flagteamid, 0] SPC "base";
	ObserverHUDMissionData.FlagStatus[%flagteamid] = "";
	ObserverHUD.Update();
}

function handleObserverHUDCTFFlagReturn (%msgType, %msgString, %clientname, %flagteamname, %flagteamid)
{
	ObserverHUDMissionData.TeamFlagReturn[%flagteamid]++;
	if(%clientname !$= "0")
	{
		%name = detag(%clientname);
		ObserverHUDMissionData.ClientFlagReturn[%name]++;
	}
	ObserverHUDMissionData.GameType = "CTF";
	ObserverHUDMissionData.FlagStatus[%flagteamid] = "";
	$ObserverHUDFlagStatus[%flagteamid] = "At" SPC $clTeamScore[%flagteamid, 0] SPC "base";
	ObserverHUD.Update();
}

//-------------------------------------------------------------------------
// CnH Specific Stuff

function handleObserverHUDCNHTeamInfo (%msgType, %msgString, %teamid, %teamname, %teamscore, %scorelimit, %teamHeld)
{
	ObserverHUDMissionData.TeamScore[%teamid] = %teamscore;
	ObserverHUDMissionData.ScoreLimit = %scorelimit;
	ObserverHUDMissionData.GameType = "CnH";
	ObserverHUD.Update();
}

function handleObserverHUDCNHTeamClaim (%msgType, %msgString, %clientname, %ffname, %taggedteamname)
{
	ObserverHUDMissionData.GameType = "CnH";
	%name = detag(%clientname);
	ObserverHUDMissionData.ClientGrab[%name]++;
	%teamname = detag(%taggedteamname);
	%teamid = ObserverHUDMissionData.TeamNametoID[%teamname];
	ObserverHUDMissionData.TeamGrab[%teamid]++;
	ObserverHUD.Update();
}

//==================================================================
//==================================================================
//
//                         Other Code
//
//==================================================================
//==================================================================
//==================================================================

//========================================================================
// Player and Objective Observing.

function ObserverHUD::ObserveClientName(%this, %clientname)
{
	if(%clientname $= "")
		return;
	%client = PlayerList.getIDByName(%clientname);
	$ObsHUd::clientName = PlayerList.getIDByName(%clientname);
	commandToServer('processGameLink', %client);
	%this.Update();
}

function ObserverHUD::ObserveFlag(%this, %teamid)
{
	if(%teamid $= "")
		return;

	%status = ObserverHUDMissionData.FlagStatus[%teamid];
	if(%status $= "" || %status $= "<At Base>" || %status $= "<In the Field>")
	{
		//flag not being carried...cant observe player
		%message = "\nObserverHUD: No client is currently carrying the flag to view.";
		clientCmdBottomPrint( %message, 1, 3 );
		return;
	}
	%name = detag(%status);
	%this.ObserveClientName(%name);
}

function ObserverHUD::AutoView(%this, %flagteam)
{
	if($ObserverHUDSettings::NoAutoView)
		return;
	else if($ObserverHUDSettings::Team1AutoViewCarrier && %flagteam == 2)
		%this.ObserveFlag(%flagteam);
	else if($ObserverHUDSettings::Team2AutoViewCarrier && %flagteam == 1)
		%this.ObserveFlag(%flagteam);
	else if($ObserverHUDSettings::AutoViewCarrier)
		%this.ObserveFlag(%flagteam);
	else
		return;
}

function ObserverHUD::GetCurrentPlayerIndex(%this)
{
	//get existing position
	%i = 0;
	%p = PlayerList.findByIndex(%i);
	while (%p !$= $PLAYER_ERROR)
	{
		if(%p.name $= %this.CurrentName)
		{
			%currentindex = %i;
			%p = $PLAYER_ERROR;
		}
		else
		{
			%i++;
			%p = PlayerList.findByIndex(%i);
		}
	}

	if(%currentindex $= "")
		%currentindex = -1;
	return %currentindex;
}

function ObserverHUD::ObserveNextTeam(%this, %team)
{
	%currentindex = %this.GetCurrentPlayerIndex();

	//get next player name
	%i = %currentindex + 1;
	%p = PlayerList.findByIndex(%i);
	%newname = "";
	while (%p !$= $PLAYER_ERROR)
	{
		if(%p.teamId == %team)
		{
			%newname = %p.name;
			%p = $PLAYER_ERROR;
		}
		else
		{
			%i++;
			%p = PlayerList.findByIndex(%i);
		}
	}
	if(%newname $= "")
	{
		%i = 0;
		%p = PlayerList.findByIndex(%i);
		while (%p !$= $PLAYER_ERROR)
		{
			if(%p.teamId == %team)
			{
				%newname = %p.name;
				%p = $PLAYER_ERROR;
			}
			else if(%i == %currentindex)
			{
				%p = $PLAYER_ERROR;
			}
			else
			{
				%i++;
				%p = PlayerList.findByIndex(%i);
			}
		}
	}
	if(%newname $= "")
		return;
	//View next player
	%this.ObserveClientName(%newname);
}

function ObserverHUD::ObservePrevTeam(%this, %team)
{
	%currentindex = %this.GetCurrentPlayerIndex();

	//get next player name
	%i = %currentindex - 1;
	%p = PlayerList.findByIndex(%i);
	%newname = "";
	while (%p !$= $PLAYER_ERROR)
	{
		if(%p.teamId == %team)
		{
			%newname = %p.name;
			%p = $PLAYER_ERROR;
		}
		else
		{
			%i--;
			%p = PlayerList.findByIndex(%i);
		}
	}
	if(%newname $= "")
	{
		%i = PlayerListGroup.getCount()-1;
		%p = PlayerList.findByIndex(%i);
		while (%p !$= $PLAYER_ERROR)
		{
			if(%p.teamId == %team)
			{
				%newname = %p.name;
				%p = $PLAYER_ERROR;
			}
			else if(%i <= %currentindex)
			{
				%p = $PLAYER_ERROR;
			}
			else
			{
				%i--;
				%p = PlayerList.findByIndex(%i);
			}
		}
	}
	if(%newname $= "")
		return;
	//View prev player
	%this.ObserveClientName(%newname);
}

function ObserverTag(%team)
{
	%count = PlayerListGroup.getCount();
	for(%i = 0; %i < %count; %i++)
	{
		%obj = PlayerListGroup.getObject(%i);
		if ( !%obj.isSmurf )
		{
			%name = %obj.name;
			%teamid = %obj.teamId;
			%pos1 = strStr(%name, "\c6");
			if(%pos1 > 0)
			{
				%pos2 = strStr(%name, "\c7");
				if(%pos2 < %pos1)
				{
					%Tag = getSubStr(%name, %pos2 + 1, %pos1 - %pos2 - 1);
				}
				else
				{
					%pos3 = strStr(%name, "\x11");
					%Tag = getSubStr(%name, %pos2 + 1, %pos3 - %pos2 - 1);
				}
			}
			if ( %Tag !$= "" )
			{
 				%tagCounts[%teamid, %Tag]++;
				if ( %tagCounts[%teamid, %Tag] > %bestTagCount[%teamid] )
				{
  					%bestTagCount[%teamid] = %tagCounts[%teamid, %Tag];
  					%bestTag[%teamid] = %Tag;
				}
			}
		}
	}
	return %bestTag[%team];
}

function ObserverGetMod()
{
	%mod = MissionCallback.getServerMod();
	if(%mod $= "")
	{
		%grav = getState(Gravity);
		switch$(%grav)
		{
			case "-26.9": %mod = "Classic";
			case "-43": %mod = "TR2";
			case "-20": %mod = "Base";
			default: %mod = "Base-Unk";
		}
	}
	return %mod;
}

//======================================================================
// Add Keys

function ObserverHUDKeys()
{
	if(!$ObserverHUDKeys)
	{
		$ObsRemapName[$ObsRemapCount] = "Quick View 1";
		$ObsRemapCmd[$ObsRemapCount] = "QuickView1";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Quick View 2";
		$ObsRemapCmd[$ObsRemapCount] = "QuickView2";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Quick View 3";
		$ObsRemapCmd[$ObsRemapCount] = "QuickView3";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Quick View 4";
		$ObsRemapCmd[$ObsRemapCount] = "QuickView4";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Quick View 5";
		$ObsRemapCmd[$ObsRemapCount] = "QuickView5";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Quick View 6";
		$ObsRemapCmd[$ObsRemapCount] = "QuickView6";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Quick View 7";
		$ObsRemapCmd[$ObsRemapCount] = "QuickView7";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Quick View 8";
		$ObsRemapCmd[$ObsRemapCount] = "QuickView8";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Quick View 9";
		$ObsRemapCmd[$ObsRemapCount] = "QuickView9";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Quick View 0";
		$ObsRemapCmd[$ObsRemapCount] = "QuickView0";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Set Quick View 1";
		$ObsRemapCmd[$ObsRemapCount] = "SetQuickView1";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Set Quick View 2";
		$ObsRemapCmd[$ObsRemapCount] = "SetQuickView2";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Set Quick View 3";
		$ObsRemapCmd[$ObsRemapCount] = "SetQuickView3";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Set Quick View 4";
		$ObsRemapCmd[$ObsRemapCount] = "SetQuickView4";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Set Quick View 5";
		$ObsRemapCmd[$ObsRemapCount] = "SetQuickView5";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Set Quick View 6";
		$ObsRemapCmd[$ObsRemapCount] = "SetQuickView6";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Set Quick View 7";
		$ObsRemapCmd[$ObsRemapCount] = "SetQuickView7";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Set Quick View 8";
		$ObsRemapCmd[$ObsRemapCount] = "SetQuickView8";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Set Quick View 9";
		$ObsRemapCmd[$ObsRemapCount] = "SetQuickView9";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Set Quick View 0";
		$ObsRemapCmd[$ObsRemapCount] = "SetQuickView0";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "View Team 1 Flag";
		$ObsRemapCmd[$ObsRemapCount] = "Team1Flag";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "View Team 2 Flag";
		$ObsRemapCmd[$ObsRemapCount] = "Team2Flag";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "View Team 1 Next";
		$ObsRemapCmd[$ObsRemapCount] = "Team1Next";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "View Team 2 Next";
		$ObsRemapCmd[$ObsRemapCount] = "Team2Next";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "View Team 1 Prev";
		$ObsRemapCmd[$ObsRemapCount] = "Team1Prev";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "View Team 2 Prev";
		$ObsRemapCmd[$ObsRemapCount] = "Team2Prev";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Toggle ObserverHUD";
		$ObsRemapCmd[$ObsRemapCount] = "ToggleObserverHUD";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Toggle Player Stats";
		$ObsRemapCmd[$ObsRemapCount] = "ToggleObserverHUDPlayerStats";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Toggle Game Stats";
		$ObsRemapCmd[$ObsRemapCount] = "ToggleObserverHUDGameStats";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Toggle Quick View";
		$ObsRemapCmd[$ObsRemapCount] = "ToggleObserverHUDQuickView";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Toggle Team Stats";
		$ObsRemapCmd[$ObsRemapCount] = "ToggleObserverHUDTeamStats";
		$ObsRemapCount++;
		$ObsRemapName[$ObsRemapCount] = "Toggle Player Details";
		$ObsRemapCmd[$ObsRemapCount] = "ToggleObserverHUDPlayerDetails";
		$ObsRemapCount++;
		OP_RemapList.fillList();
		$ObserverHUDKeys = true;
	}
}


function QuickView1(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(1, false);
	}
}

function QuickView2(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(2, false);
	}
}

function QuickView3(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(3, false);
	}
}

function QuickView4(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(4, false);
	}
}

function QuickView5(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(5, false);
	}
}

function QuickView6(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(6, false);
	}
}

function QuickView7(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(7, false);
	}
}

function QuickView8(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(8, false);
	}
}

function QuickView9(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(9, false);
	}
}

function QuickView0(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(0, false);
	}
}

function SetQuickView1(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(1, true);
	}
}

function SetQuickView2(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(2, true);
	}
}

function SetQuickView3(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(3, true);
	}
}

function SetQuickView4(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(4, true);
	}
}

function SetQuickView5(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(5, true);
	}
}

function SetQuickView6(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(6, true);
	}
}

function SetQuickView7(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(7, true);
	}
}

function SetQuickView8(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(8, true);
	}
}

function SetQuickView9(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(9, true);
	}
}

function SetQuickView0(%val)
{
	if(%val)
	{
		ObserverHUD.QuickViewButton(0, true);
	}
}

function Team1Flag(%val)
{
	if(%val)
	{
		ObserverHUD.ObserveFlag(1);
	}
}

function Team2Flag(%val)
{
	if(%val)
	{
		ObserverHUD.ObserveFlag(2);
	}
}

function Team1Next(%val)
{
	if(%val)
	{
		ObserverHUD.ObserveNextTeam(1);
	}
}

function Team2Next(%val)
{
	if(%val)
	{
		ObserverHUD.ObserveNextTeam(2);
	}
}

function Team1Prev(%val)
{
	if(%val)
	{
		ObserverHUD.ObservePrevTeam(1);
	}
}

function Team2Prev(%val)
{
	if(%val)
	{
		ObserverHUD.ObservePrevTeam(2);
	}
}

function ToggleObserverHUD(%val)
{
	if(%val)
	{
		ObserverHUD.ToggleHud(All);
	}
}

function ToggleObserverHUDPlayerStats(%val)
{
	if(%val)
	{
		ObserverHUD.ToggleHud(PlayerStats);
	}
}

function ToggleObserverHUDPlayerDetails(%val)
{
	if(%val)
	{
		ObserverHUD.ToggleHud(PlayerDetails);
	}
}

function ToggleObserverHUDGameStats(%val)
{
	if(%val)
	{
		ObserverHUD.ToggleHud(GameStats);
	}
}

function ToggleObserverHUDQuickView(%val)
{
	if(%val)
	{
		ObserverHUD.ToggleHud(QuickView);
	}
}

function ToggleObserverHUDTeamStats(%val)
{
	if(%val)
	{
		ObserverHUD.ToggleHud(TeamStats);
	}
}

function ObserverHUD::QuickViewButton(%this, %key, %set)
{
	if(%set)
	{
		%rawname = %this.CurrentName;
		%clientid = PlayerList.getIDByName(%rawname);
		%this.QuickListPlayer[%key] = %clientid;
		%this.QuickViewUpdate();
	}
	else
	{
		%clientid = %this.QuickListPlayer[%key];
		if(%clientid $= "" || %clientid == 0)
			return;
		%name = PlayerList.getNameByID(%clientid);
		%this.ObserveClientName(%name);
		%this.Update();
	}
}

function ObserverHUD::ToggleHud(%this, %hudname)
{
	if(%hudname $= "TeamStats")
	{
		$ObserverHUDSettings::EnableTeamStats = $ObserverHUDSettings::EnableTeamStats ? false : true;
		%this.TeamStatsCreate();
	}
	else if(%hudname $= "QuickView")
	{
		$ObserverHUDSettings::EnableQuickView = $ObserverHUDSettings::EnableQuickView ? false : true;
		%this.QuickViewCreate();
	}
	else if(%hudname $= "GameStats")
	{
		$ObserverHUDSettings::EnableGameType = $ObserverHUDSettings::EnableGameType ? false : true;
		%this.GameTypeCreate();
	}
	else if(%hudname $= "PlayerStats")
	{
		$ObserverHUDSettings::EnablePlayerStats = $ObserverHUDSettings::EnablePlayerStats ? false : true;
		%this.PlayerCreate();
	}
	else if(%hudname $= "PlayerDetails")
	{
		$ObserverHUDSettings::EnablePlayerDetail = $ObserverHUDSettings::EnablePlayerDetail ? false : true;
		%this.PlayerDetailCreate();
	}
	else
	{
		if($ObserverHUDSettings::EnableHUD $= "")
			$ObserverHUDSettings::EnableHUD = true;
		if($ObserverHUDSettings::EnableHUD)
		{
			$ObserverHUDSettings::EnableTeamStats = false;
			$ObserverHUDSettings::EnableQuickView = false;
			$ObserverHUDSettings::EnableGameType = false;
			$ObserverHUDSettings::EnablePlayerStats = false;
			$ObserverHUDSettings::EnablePlayerDetail = false;
			$ObserverHUDSettings::EnableHUD = false;
		}
		else
		{
			$ObserverHUDSettings::EnablePlayerDetail = true;
			$ObserverHUDSettings::EnableTeamStats = true;
			$ObserverHUDSettings::EnableQuickView = true;
			$ObserverHUDSettings::EnableGameType = true;
			$ObserverHUDSettings::EnablePlayerStats = true;
			$ObserverHUDSettings::EnableHUD = true;
		}
		%this.Create();
	}
}

//================================================================
// Package

package ObserverHUD
{
	function DisconnectedCleanup()
	{
		ObserverHUD.ClientDisconnect = true;
		if($ObserverHUDSettings::StatsOutputDisconnect)
		{
			ObserverHUD.OutputStats(true);
		}
		ObserverHUD.StatReset();
		parent::DisconnectedCleanup();
	}

	function clientCmdBottomPrint( %message, %time, %lines )
	{
		
		if (strstr(%message, "\nYou are now observing") != -1)
		{
			%length = strlen(%message);
			ObserverHUD.CurrentName = getSubStr(%message, 24, %length-24);
			ObserverHUD.Client = PlayerList.getIDByName(ObserverHUD.CurrentName);	
			ObserverHUD.PlayerUpdate();
			ObserverHUD.PlayerDetailUpdate();
		}

		else if ((strstr(%message, "You are now observing:\n") != -1) && (strstr(%message, "Team") != -1))
		{
			%namestart = strstr( %message, "\x10" );
			%namestop = strstr( %message, "\x11" );
			// echo(getSubStr(%message, %namestart, (%namestop - %namestart)+1));
			ObserverHUD.CurrentName = getSubStr(%message, %namestart, (%namestop - %namestart)+1);
			ObserverHUD.Client = PlayerList.getIDByName(ObserverHUD.CurrentName);
			ObserverHUD.PlayerUpdate();
			ObserverHUD.PlayerDetailUpdate();
		}
		
		else if(strstr(%message, "Observer Fly Mode") != -1)
		{
			ObserverHUD.CurrentName = "";
			ObserverHUD.Client = "";
		}
		parent::clientCmdBottomPrint( %message, %time, %lines );
	}
	
	function OptionsDlg::onWake( %this )
	{
		ObserverHUDKeys();
		Parent::onWake( %this );
	}
};
activatepackage(ObserverHUD);


//==================================================================
//==================================================================
//
//                         SETTINGS FILE
//
//==================================================================
//==================================================================
//==================================================================

function ObserverHUD::CreateSettings(%this)
{
	$ObserverHUDSettings::EnableHUD = $ObserverHUDSettings::EnableHUD $= "" ? 1 : $ObserverHUDSettings::EnableHUD;
	$ObserverHUDSettings::EnableTeamStats = $ObserverHUDSettings::EnableTeamStats $= "" ? 1 : $ObserverHUDSettings::EnableTeamStats;
	$ObserverHUDSettings::EnableGameType = $ObserverHUDSettings::EnableGameType $= "" ? 1 : $ObserverHUDSettings::EnableGameType;
	$ObserverHUDSettings::EnablePlayerStats = $ObserverHUDSettings::EnablePlayerStats $= "" ? 1 : $ObserverHUDSettings::EnablePlayerStats;
	$ObserverHUDSettings::EnablePlayerDetail = $ObserverHUDSettings::EnablePlayerDetail $= "" ? 1 : $ObserverHUDSettings::EnablePlayerDetail;
	$ObserverHUDSettings::EnableQuickView = $ObserverHUDSettings::EnableQuickView $= "" ? 0 : $ObserverHUDSettings::EnableQuickView;
	$ObserverHUDSettings::PingCheck = $ObserverHUDSettings::PingCheck $= "" ? 0 : $ObserverHUDSettings::PingCheck;
	$ObserverHUDSettings::AutoViewCarrier = $ObserverHUDSettings::AutoViewCarrier $= "" ? 0 : $ObserverHUDSettings::AutoViewCarrier;
	$ObserverHUDSettings::Team1AutoViewCarrier = $ObserverHUDSettings::Team1AutoViewCarrier $= "" ? 0 : $ObserverHUDSettings::Team1AutoViewCarrier;
	$ObserverHUDSettings::Team2AutoViewCarrier = $ObserverHUDSettings::Team2AutoViewCarrier $= "" ? 0 : $ObserverHUDSettings::Team2AutoViewCarrier;
	$ObserverHUDSettings::NoAutoView = $ObserverHUDSettings::NoAutoView $= "" ? 1 : $ObserverHUDSettings::NoAutoView;

	$ObserverHUDSettings::AutoStatsOutput = $ObserverHUDSettings::AutoStatsOutput $= "" ? 0 : $ObserverHUDSettings::AutoStatsOutput;
	$ObserverHUDSettings::PromptStatsOutput = $ObserverHUDSettings::PromptStatsOutput $= "" ? 0 : $ObserverHUDSettings::PromptStatsOutput;
	$ObserverHUDSettings::NoStatsOutput = $ObserverHUDSettings::NoStatsOutput $= "" ? 1 : $ObserverHUDSettings::NoStatsOutput;
	$ObserverHUDSettings::OutputTimer = $ObserverHUDSettings::OutputTimer $= "" ? 0 : $ObserverHUDSettings::OutputTimer;
	$ObserverHUDSettings::StatsOutputDisconnect = $ObserverHUDSettings::StatsOutputDisconnect $= "" ? 0 : $ObserverHUDSettings::StatsOutputDisconnect;
	$ObserverHUDSettings::SpecificLocation = $ObserverHUDSettings::SpecificLocation $= "" ? "default" : $ObserverHUDSettings::SpecificLocation;
	$ObserverHUDSettings::MaxPlayerLimit = $ObserverHUDSettings::MaxPlayerLimit $= "" ? 0 : $ObserverHUDSettings::MaxPlayerLimit;
	$ObserverHUDSettings::ClanName1 = $ObserverHUDSettings::ClanName1 $= "" ? "Team Pub One" : $ObserverHUDSettings::ClanName1;
	$ObserverHUDSettings::ClanName2 = $ObserverHUDSettings::ClanName2 $= "" ? "Team Pub Two" : $ObserverHUDSettings::ClanName2;
	
	
	$ObserverHUDSettings::FormatPlayerDetails = $ObserverHUDSettings::FormatPlayerDetails $= "" ? 1 : $ObserverHUDSettings::FormatPlayerDetails;
	$ObserverHUDSettings::FormatTeamDetails = $ObserverHUDSettings::FormatTeamDetails $= "" ? 1 : $ObserverHUDSettings::FormatTeamDetails;
	$ObserverHUDSettings::FormatServerDetails = $ObserverHUDSettings::FormatServerDetails $= "" ? 1 : $ObserverHUDSettings::FormatServerDetails;
	$ObserverHUDSettings::UseCssFile = $ObserverHUDSettings::UseCssFile $= "" ? 1 : $ObserverHUDSettings::UseCssFile;
	$ObserverHUDSettings::UseHtmlFile = $ObserverHUDSettings::UseHtmlFile $= "" ? 0 : $ObserverHUDSettings::UseHtmlFile;
	$ObserverHUDSettings::ColourScheme = $ObserverHUDSettings::ColourScheme $= "" ? "White" : $ObserverHUDSettings::ColourScheme;
	$ObserverHUDSettings::MainWidth = $ObserverHUDSettings::MainWidth $= "" ? "600" : $ObserverHUDSettings::MainWidth;
	
	$ObserverHUDSettings::KillColor = $ObserverHUDSettings::KillColor $= "" ? "<color:A9D7FA>" : $ObserverHUDSettings::KillColor;
	$ObserverHUDSettings::DeathColor = $ObserverHUDSettings::DeathColor $= "" ? "<color:A9D7FA>" : $ObserverHUDSettings::DeathColor;
	$ObserverHUDSettings::StatColor = $ObserverHUDSettings::StatColor $= "" ? "<color:A9D7FA>" : $ObserverHUDSettings::StatColor;
	$ObserverHUDSettings::InfoColor = $ObserverHUDSettings::InfoColor $= "" ? "<color:A9D7FA>" : $ObserverHUDSettings::InfoColor;
	$ObserverHUDSettings::TitleColor = $ObserverHUDSettings::TitleColor $= "" ? "<color:A9D7FA>" : $ObserverHUDSettings::TitleColor;
	
	if(!isobject(%this.fileeditor))
	{
		 %this.fileeditor = new FileObject();
	}

	%this.fileeditor.openForWrite("prefs/ObserverHUDPrefs.cs");
	%this.fileeditor.writeline("//         ObserverHUD Pref File");
	%this.fileeditor.writeline("//");
	%this.fileeditor.writeline("//	Settings may be altered in this file but you are better off using the GUI");
	%this.fileeditor.writeline("// 	in the in-game scripts browser for any alterations to this file.");
	%this.fileeditor.writeline("// ");
	%this.fileeditor.writeline("// 	Your changes will not become current until you restart Tribes 2 if edited here.");
	%this.fileeditor.writeline("// ");
	%this.fileeditor.writeline("// 	Note: Please do not change your colour scheme in this file. Use the GUI.");
	%this.fileeditor.writeline("// ");
	%this.fileeditor.writeline("// ===========================================================================");
	%this.fileeditor.writeline("$ObserverHUDVersion = \"" @ %this.Version @ "\";");
	%this.fileeditor.writeline("//");
	%this.fileeditor.writeline("//");
	%this.fileeditor.writeline("//	Main");
	%this.fileeditor.writeline("$ObserverHUDSettings::EnableHUD = "@$ObserverHUDSettings::EnableHUD@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::EnableTeamStats = "@$ObserverHUDSettings::EnableTeamStats@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::EnableGameType = "@$ObserverHUDSettings::EnableGameType@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::EnablePlayerStats = "@$ObserverHUDSettings::EnablePlayerStats@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::EnablePlayerDetail = "@$ObserverHUDSettings::EnablePlayerDetail@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::EnableQuickView = "@$ObserverHUDSettings::EnableQuickView@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::PingCheck = "@$ObserverHUDSettings::PingCheck@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::AutoViewCarrier = "@$ObserverHUDSettings::AutoViewCarrier@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::Team1AutoViewCarrier = "@$ObserverHUDSettings::Team1AutoViewCarrier@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::Team2AutoViewCarrier = "@$ObserverHUDSettings::Team2AutoViewCarrier@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::NoAutoView = "@$ObserverHUDSettings::NoAutoView@";");
	%this.fileeditor.writeline("//");
	%this.fileeditor.writeline("//");
	%this.fileeditor.writeline("//	Html Settings");
	%this.fileeditor.writeline("$ObserverHUDSettings::AutoStatsOutput = "@$ObserverHUDSettings::AutoStatsOutput@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::PromptStatsOutput = "@$ObserverHUDSettings::PromptStatsOutput@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::NoStatsOutput = "@$ObserverHUDSettings::NoStatsOutput@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::OutputTimer = "@$ObserverHUDSettings::OutputTimer@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::StatsOutputDisconnect = "@$ObserverHUDSettings::StatsOutputDisconnect@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::SpecificLocation = \""@$ObserverHUDSettings::SpecificLocation@"\";");
	%this.fileeditor.writeline("$ObserverHUDSettings::MaxPlayerLimit = "@$ObserverHUDSettings::MaxPlayerLimit@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::ClanName1 = \""@$ObserverHUDSettings::ClanName1@"\";");
	%this.fileeditor.writeline("$ObserverHUDSettings::ClanName2 = \""@$ObserverHUDSettings::ClanName2@"\";");
	%this.fileeditor.writeline("//");
	%this.fileeditor.writeline("//");
	%this.fileeditor.writeline("//	Formatting Settings");
	%this.fileeditor.writeline("$ObserverHUDSettings::MainWidth = "@$ObserverHUDSettings::MainWidth@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::UseCssFile = "@$ObserverHUDSettings::UseCssFile@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::UseHtmlFile = "@$ObserverHUDSettings::UseHtmlFile@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::ColourScheme = \""@$ObserverHUDSettings::ColourScheme@"\";");
	%this.fileeditor.writeline("$ObserverHUDSettings::FormatPlayerDetails = "@$ObserverHUDSettings::FormatPlayerDetails@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::FormatTeamDetails = "@$ObserverHUDSettings::FormatTeamDetails@";");
	%this.fileeditor.writeline("$ObserverHUDSettings::FormatServerDetails = "@$ObserverHUDSettings::FormatServerDetails@";");
	%this.fileeditor.writeline("//");
	%this.fileeditor.writeline("//");
	%this.fileeditor.writeline("//	Color Settings");
	%this.fileeditor.writeline("$ObserverHUDSettings::KillColor = \""@$ObserverHUDSettings::KillColor@"\";");
	%this.fileeditor.writeline("$ObserverHUDSettings::DeathColor = \""@$ObserverHUDSettings::DeathColor@"\";");
	%this.fileeditor.writeline("$ObserverHUDSettings::StatColor = \""@$ObserverHUDSettings::StatColor@"\";");
	%this.fileeditor.writeline("$ObserverHUDSettings::InfoColor = \""@$ObserverHUDSettings::InfoColor@"\";");
	%this.fileeditor.writeline("$ObserverHUDSettings::TitleColor = \""@$ObserverHUDSettings::TitleColor@"\";");
	%this.fileeditor.close();
	exec("prefs/ObserverHUDPrefs.cs");
	
	
}

// Message callbacks
addMessageCallback('MsgMissionStart', handleObserverHUDMissionStart );
addMessageCallback('MsgMissionEnd', handleObserverHUDMissionEnd );
addMessageCallback('MsgAdminChangeMission', handleObserverHUDMissionEnd );
addMessageCallback('MsgClearDebrief',handleObserverHUDMissionEndBackup );
addMessageCallback('MsgClientJoin', handleObserverHUDClientJoined );
addMessageCallback('MsgSystemClock', handleObserverHUDTimer );
addMessageCallback('MsgClientDrop', handleObserverHUDClientDrop );
addMessageCallback('MsgTeamScoreIs', handleObserverHUDTeamScore );
addMessageCallback('MsgClientDrop', handleObserverHUDTeamScore );
addMessageCallback('MsgClientJoinTeam', handleObserverHUDClientInfo );
addMessageCallback('MsgMissionDropInfo', handleObserverHUDMissionInfo );
addMessageCallback('MsgClaimFlipFlop', handleObserverHUDCNHTeamClaim );
addMessageCallback('MsgCnHAddTeam', handleObserverHUDCNHTeamInfo );
// CTF Callbacks
addMessageCallback('MsgCTFFlagReturned', handleObserverHUDCTFFlagReturn );
addMessageCallback('MsgCTFFlagCapped', handleObserverHUDCTFFlagCapped );
addMessageCallback('MsgCTFFlagDropped', handleObserverHUDCTFFlagDropped );
addMessageCallback('MsgCTFFlagTaken', handleObserverHUDCTFFlagTaken );
addMessageCallback('MsgCTFAddTeam', handleObserverHUDCTFTeamInfo );
// Kill Callbacks
Callback.add(KillCallback,"ObserverHUD.onKill");
Callback.add(msgVehicleCrash,"ObserverHUD.onKill");
// HUD KillBacks
Callback.add(KillCallback,"ObserverHUD.Update");
