//==============================================================
// GUI

if(!isObject(ObserverHUDGUI))
{
	new GuiControl(ObserverHUDGUI) {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = "390 315";
		minExtent = "390 315";
		visible = "1";
		helpTag = "0";

		new ShellScrollCtrl(ObserverHUDGUI_Scroll) {
			profile = "NewScrollCtrlProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "5 6";
			extent = "389 314";
			minExtent = "389 314";
			visible = "1";
			helpTag = "0";
			willFirstRespond = "1";
			hScrollBar = "dynamic";
			vScrollBar = "dynamic";
			constantThumbHeight = "0";
			defaultLineHeight = "15";
			childMargin = "0 3";
			fieldBase = "gui/shll_field";

			new ShellPaneCtrl() {
				profile = "ShellDlgPaneProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "-16 24";
				extent = "600 389";
				minExtent = "48 92";
				visible = "1";
				helpTag = "0";
				text = "OBSERVERHUD CONFIG";
				maxLength = "255";
				noTitleBar = "0";

				new ShellTabFrame() {
					profile = "ShellHorzTabFrameProfile";
					horizSizing = "width";
					vertSizing = "bottom";
					position = "20 51";
					extent = "560 319";
					minExtent = "26 319";
					visible = "1";
					helpTag = "0";
					isVertical = "0";
					useCloseButton = "0";
					edgeInset = "0";
				};
				new ShellTabGroupCtrl(ObserverHUD_TabView) {
					profile = "TabGroupProfile";
					horizSizing = "width";
					vertSizing = "bottom";
					position = "30 22";
					extent = "560 29";
					minExtent = "38 29";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					glowOffset = "7";
					tabSpacing = "2";
					maxTabWidth = "120";
					stretchToFit = "0";
				};

				new ShellFieldCtrl(ObserverHUD_MainPane) {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "28 60";
					extent = "547 301";
					minExtent = "16 18";
					visible = "0";
					helpTag = "0";

					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "35 14";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Please refer to the readme pane for details on each option.";
						maxLength = "255";
					};
					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "35 30";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Do not forget to use the Apply Changes button to save your setting changes.";
						maxLength = "255";
					};
					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "60 245";
						extent = "173 38";
						minExtent = "32 38";
						visible = "1";
						command = "ObserverHUDApplyChanges();";
						helpTag = "0";
						text = "APPLY CHANGES";
						simpleStyle = "0";
					};
					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 245";
						extent = "173 38";
						minExtent = "32 38";
						visible = "1";
						command = "ObserverHUDDefaultKeys();";
						helpTag = "0";
						text = "SET DEFAULT KEYS";
						simpleStyle = "0";
					};
					new ShellToggleButton() {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "60 65";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::EnableHUD";
						helpTag = "0";
						text = "Enable ObserverHUD HUDs";
						maxLength = "255";
					};
					new ShellToggleButton() {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "60 95";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::EnableTeamStats";
						helpTag = "0";
						text = "Enable Team Stats HUD";
						maxLength = "255";
					};
					new ShellToggleButton() {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "60 125";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::EnableGameType";
						helpTag = "0";
						text = "Enable Game Type Stats HUD";
						maxLength = "255";
					};
					new ShellToggleButton() {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "60 155";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::EnablePlayerStats";
						helpTag = "0";
						text = "Enable Player Stats HUD";
						maxLength = "255";
					};
					new ShellToggleButton() {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "60 185";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::EnableQuickView";
						helpTag = "0";
						text = "Enable Quick View HUD";
						maxLength = "255";
					};
					new ShellToggleButton() {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "60 215";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::EnablePlayerDetail";
						helpTag = "0";
						text = "Enable Player Deatil Kill/Deaths";
						maxLength = "255";
					};
					new ShellToggleButton() {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 65";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::PingCheck";
						helpTag = "0";
						text = "Enable Ping/PL Updates";
						maxLength = "255";
					};
					new ShellToggleButton(ObserverHUD_Auto1) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 95";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::AutoViewCarrier";
						helpTag = "0";
						text = "Auto View Any Flag Carrier";
						maxLength = "255";
					};
					new ShellToggleButton(ObserverHUD_Auto2) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 125";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::Team1AutoViewCarrier";
						helpTag = "0";
						text = "Team 1 Flag Carrier Only";
						maxLength = "255";
					};
					new ShellToggleButton(ObserverHUD_Auto3) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 155";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::Team2AutoViewCarrier";
						helpTag = "0";
						text = "Team 2 Flag Carrier Only";
						maxLength = "255";
					};
					new ShellToggleButton(ObserverHUD_Auto4) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 185";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::NoAutoView";
						helpTag = "0";
						text = "Dont Auto View";
						maxLength = "255";
					};
				};
				new ShellFieldCtrl(ObserverHUD_HtmlPane) {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "28 60";
					extent = "547 301";
					minExtent = "16 18";
					visible = "0";
					helpTag = "0";

					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 30";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Stat output on mission end";
						maxLength = "255";
					};
					new ShellToggleButton(ObserverHUD_Stats3) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 110";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::AutoStatsOutput";
						helpTag = "0";
						text = "Auto Stats Output";
						maxLength = "255";
					};
					new ShellToggleButton(ObserverHUD_Stats2) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 80";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::PromptStatsOutput";
						helpTag = "0";
						text = "Prompt for Stats Output";
						maxLength = "255";
					};
					new ShellToggleButton(ObserverHUD_Stats1) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 50";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::NoStatsOutput";
						helpTag = "0";
						text = "No Stats Output";
						maxLength = "255";
					};
					new ShellToggleButton(ObserverHUD_StatsDisconnect) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 150";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::StatsOutputDisconnect";
						helpTag = "0";
						text = "Output Stats on Disconnect";
						maxLength = "255";
					};
					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 195";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Ingame html output frequency";
						maxLength = "255";
					};
					new GuiTextCtrl(ObserverHUD_OutputTimerTxt) {
						profile = "ShellTextCenterProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "350 212";
						extent = "50 24";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Disabled";
						maxLength = "255";
					};
					new ShellSliderCtrl(ObserverHUD_OutputTimer) {
						profile = "ShellSliderProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 210";
						extent = "170 24";
						minExtent = "12 24";
						visible = "1";
						variable = "value";
						altCommand = "ObserverHUD.OutputTimerAdjust();";
						helpTag = "0";
						range = "0 600";
						ticks = "16";
						value = "1";
						usePlusMinus = "0";
					};
					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 235";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Ingame output html file name";
						maxLength = "255";
					};
					new ShellTextEditCtrl(ObserverHUD_SpecificFile) {
						profile = "NewTextEditProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "295 255";
						extent = "180 38";
						minExtent = "32 38";
						visible = "1";
						variable = "$ObserverHUDSettings::SpecificLocation";
						text = $ObserverHUDSettings::SpecificLocation;						
						helpTag = "0";
						maxLength = "16";
						historySize = "0";
						password = "0";
						glowOffset = "9 9";
					};
					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "30 30";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Team 1 Clan Name";
						maxLength = "255";
					};
					new ShellTextEditCtrl(ObserverHUD_ClanName1) {
						profile = "NewTextEditProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "25 50";
						extent = "180 38";
						minExtent = "32 38";
						visible = "1";
						variable = "$ObserverHUDSettings::ClanName1";
						text = $ObserverHUDSettings::ClanName1;
						helpTag = "0";
						maxLength = "16";
						historySize = "0";
						password = "0";
						glowOffset = "9 9";
					};
					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "30 95";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Team 2 Clan Name";
						maxLength = "255";
					};
					new ShellTextEditCtrl(ObserverHUD_ClanName2) {
						profile = "NewTextEditProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "25 115";
						extent = "180 38";
						minExtent = "32 38";
						visible = "1";
						variable = "$ObserverHUDSettings::ClanName2";
						text = $ObserverHUDSettings::ClanName2;
						helpTag = "0";
						maxLength = "16";
						historySize = "0";
						password = "0";
						glowOffset = "9 9";
					};
					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "30 165";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Max Players per Team";
						maxLength = "255";
					};
					new GuiTextCtrl(ObserverHUD_MaxPlayersTxt) {
						profile = "ShellTextCenterProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "80 182";
						extent = "50 24";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Unknown";
						maxLength = "255";
					};
					new ShellSliderCtrl(ObserverHUD_MaxPlayers) {
						profile = "ShellSliderProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "30 180";
						extent = "170 24";
						minExtent = "12 24";
						visible = "1";
						variable = "value";
						altCommand = "ObserverHUD.MaxPlayersAdjust();";
						helpTag = "0";
						range = "0 32";
						ticks = "32";
						value = "1";
						usePlusMinus = "0";
					};

					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "60 245";
						extent = "173 38";
						minExtent = "32 38";
						visible = "1";
						command = "ObserverHUDApplyChanges();";
						helpTag = "0";
						text = "APPLY CHANGES";
						simpleStyle = "0";
					};
				};
				new ShellFieldCtrl(ObserverHUD_FormatPane) {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "28 60";
					extent = "547 301";
					minExtent = "16 18";
					visible = "0";
					helpTag = "0";

					new ShellToggleButton() {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "30 140";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::FormatServerDetails";
						helpTag = "0";
						text = "Output Server Details";
						maxLength = "255";
					};
					new ShellToggleButton() {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "30 170";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::FormatTeamDetails";
						helpTag = "0";
						text = "Output Team Details";
						maxLength = "255";
					};
					new ShellToggleButton() {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "30 200";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::FormatPlayerDetails";
						helpTag = "0";
						text = "Output Player Details";
						maxLength = "255";
					};
					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 130";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Main html table width (eg. 600 or 60%)";
						maxLength = "255";
					};
					new ShellTextEditCtrl(ObserverHUD_HtmlWidth) {
						profile = "NewTextEditProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "290 150";
						extent = "100 38";
						minExtent = "32 38";
						visible = "1";
						variable = "$ObserverHUDSettings::MainWidth";
						helpTag = "0";
						maxLength = "16";
						historySize = "0";
						password = "0";
						glowOffset = "9 9";
					};
					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 30";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Colour Scheme";
						maxLength = "255";
					};
					new ShellPopupMenu(ObserverHUD_ColourScheme) {
						profile = "ShellPopupProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "300 60";
						extent = "169 36";
						minExtent = "49 36";
						visible = "1";
						helpTag = "0";
						text = "Colour Scheme";
						maxLength = "255";
						maxPopupHeight = "200";
						buttonBitmap = "gui/shll_pulldown";
						rolloverBarBitmap = "gui/shll_pulldownbar_rol";
						selectedBarBitmap = "gui/shll_pulldownbar_act";
						noButtonStyle = "0";
					};
					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "30 30";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Style Sheets (HTML Formatting)";
						maxLength = "255";
					};
					new ShellToggleButton(ObserverHUD_CSSFileDisabled) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "30 60";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::UseHtmlFile";
						helpTag = "0";
						text = "Generate CSS in-line";
						maxLength = "255";
					};
					new ShellToggleButton(ObserverHUD_CSSFileEnabled) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "30 90";
						extent = "170 30";
						minExtent = "26 27";
						visible = "1";
						variable = "$ObserverHUDSettings::UseCssFile";
						helpTag = "0";
						text = "Generate seperate CSS file";
						maxLength = "255";
					};
					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "60 245";
						extent = "173 38";
						minExtent = "32 38";
						visible = "1";
						command = "ObserverHUDApplyChanges();";
						helpTag = "0";
						text = "APPLY CHANGES";
						simpleStyle = "0";
					};
				};
				new ShellFieldCtrl(ObserverHUD_ColorPane) {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "28 60";
					extent = "547 301";
					minExtent = "16 18";
					visible = "0";
					helpTag = "0";

					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "35 14";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "This is where you can setup the look of your Huds.";
						maxLength = "255";
					};
					
					new GuiTextCtrl() {
						profile = "ShellTextProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "35 30";
						extent = "440 22";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						text = "Select the Field you requre to be changed & select the color in the popup.";
						maxLength = "255";
					};					
					
					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "20 55";
						extent = "130 30";
						minExtent = "26 27";
						command = "setRGBcolor(\"$OHudKillColor\", \"ObserverHUD.SetKillColor();\");";
						visible = "1";
						helpTag = "0";
						text = "Set Kills Color";
						maxLength = "255";
					};					

					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "20 85";
						extent = "130 30";
						minExtent = "26 27";
						command = "setRGBcolor(\"$OHudDeathColor\", \"ObserverHUD.SetDeathColor();\");";
						visible = "1";
						helpTag = "0";
						text = "Set Deaths Color";
						maxLength = "255";
					};

					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "20 115";
						extent = "130 30";
						minExtent = "26 27";
						command = "setRGBcolor(\"$OHudInfoColor\", \"ObserverHUD.SetInfoColor();\");";
						visible = "1";
						helpTag = "0";
						text = "Set Info Color";
						maxLength = "255";
					};					

					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "20 145";
						extent = "130 30";
						minExtent = "26 27";
						command = "setRGBcolor(\"$OHudStatColor\", \"ObserverHUD.SetStatColor();\");";
						visible = "1";
						helpTag = "0";
						text = "Set Stat Color";
						maxLength = "255";
					};
					
					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "20 175";
						extent = "130 30";
						minExtent = "26 27";
						command = "setRGBcolor(\"$OHudTitleColor\", \"ObserverHUD.SetTitleColor();\");";
						visible = "1";
						helpTag = "0";
						text = "Set Title Color";
						maxLength = "255";
					};
					
					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "center";
						vertSizing = "bottom";
						position = "0 245";
						extent = "173 38";
						minExtent = "32 38";
						visible = "1";
						command = "ObserverHUDApplyChanges();";
						helpTag = "0";
						text = "APPLY CHANGES";
						simpleStyle = "0";
					};                                	
                                	
                                	new ShellFieldCtrl()
                                	{
                                		profile = "GuiChatBackProfile";
                                		horizSizing = "right";
                                		vertSizing = "bottom";
                                		position = "200 55";
                                		extent = "130 160";
                                
                                		new GuiMLTextCtrl(ObsHudColorGui_TeamName)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 4";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		new GuiMLTextCtrl(ObsHudColorGui_KillsCount)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 24";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		new GuiMLTextCtrl(ObsHudColorGui_TurretKillCount)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 39";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		new GuiMLTextCtrl(ObsHudColorGui_TKCount)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 54";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		new GuiMLTextCtrl(ObsHudColorGui_SuicideCount)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 69";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		new GuiMLTextCtrl(ObsHudColorGui_DeathCount)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 84";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		new GuiMLTextCtrl(ObsHudColorGui_TurretDeathCount)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 99";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		new GuiMLTextCtrl(ObsHudColorGui_OtherDeathCount)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 114";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		new GuiMLTextCtrl(ObsHudColorGui_PlayerCount)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 129";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                	};	

                                	new ShellFieldCtrl()
                                	{
                                		profile = "GuiChatBackProfile";
                                		horizSizing = "right";
                                		vertSizing = "bottom";
                                		position = "340 55";
                                		extent = "130 160";
                                
                                		new GuiMLTextCtrl(ObsHudColorGui_PlayerName)
                                		{
                                			profile = "ObserverHudHdrProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 4";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		new GuiMLTextCtrl(ObsHudColorGui_KillDeathtxt)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 24";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		new GuiMLTextCtrl(ObsHudColorGui_KillDeath1)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 39";
                                			extent = "118 25";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};
                                		
                                		new GuiMLTextCtrl(ObsHudColorGui_KillDeath2)
                                		{
                                			profile = "GuiAmmoHudProfile";
                                			horizSizing = "right";
                                			vertSizing = "bottom";
                                			position = "6 54";
                                			extent = "118 40";
                                			minExtent = "8 8";
                                			visible = "1";
                                			helpTag = "0";
                                			text = "";
                                			maxLength = "255";
                                		};         		
                                	};									
				};				
			};
		};
	};
}

function ObserverHUDGUI::onWake( %this )
{
   	// Save the cursor state since it's possible we will be coming from the sim:
   	%this.wasCursorOn = Canvas.isCursorOn();
   	if ( !%this.wasCursorOn )
      	CursorOn();

   	$enableDirectInput = "1";
   	activateDirectInput();
   	
	if ( ObserverHUD_TabView.tabCount() == 0 )
	{
		ObserverHUD_TabView.addTab( 1, "MAIN" );
	      	ObserverHUD_TabView.addTab( 2, "HTML SETUP" );
	      	ObserverHUD_TabView.addTab( 3, "HTML FORMAT");
	      	ObserverHUD_TabView.addTab( 4, "COLOR FORMAT");
	}   	

	switch$ ( %this.pane )
	{
      		case "Html":
        		ObserverHUD_TabView.setSelected( 2 );
      		case "Format":
        		ObserverHUD_TabView.setSelected( 3 );
      		case "Color":
        		ObserverHUD_TabView.setSelected( 4 );
      		default: 
        		ObserverHUD_TabView.setSelected( 1 );
   	}   	
   	

	//init controls
	ObserverHUD_OutputTimer.setValue( $ObserverHUDSettings::OutputTimer );
	ObserverHUD_MaxPlayers.setValue( $ObserverHUDSettings::MaxPlayerLimit );
	ObserverHUD_ColourScheme.clear();
	for(%i = 1; %i <= $ObserverHUDSettings::ColourSchemeMax; %i++)
	{
		ObserverHUD_ColourScheme.add( $ObserverHUDSettings::IdtoColourScheme[%i], %i);
	}
	%selId = $ObserverHUDSettings::ColourSchemetoID[$ObserverHUDSettings::ColourScheme];
	ObserverHUD_ColourScheme.setSelected(%selId);

	//init Active Controls
	ObserverHUD.OutputTimerAdjust();
	ObserverHUD.MaxPlayersAdjust();
}

function ObserverHUD_TabView::onSelect( %this, %id, %text )
{
	ObserverHUD_MainPane.setVisible( %id == 1 );
	ObserverHUD_HtmlPane.setVisible( %id == 2 );
	ObserverHUD_FormatPane.setVisible( %id == 3 );
	ObserverHUD_ColorPane.setVisible( %id == 4 );

	%ctrl = "ObserverHUD_" @ ObserverHUDGUI.pane @ "Pane";
	if ( isObject( %ctrl ) )
		%ctrl.onDeactivate();

	switch ( %id )
	{
		case 1:
			ObserverHUD_MainPane.onActivate();
		case 2:
			ObserverHUD_HtmlPane.onActivate();
		case 3:
			ObserverHUD_FormatPane.onActivate();
		case 4:
			ObserverHUD_ColorPane.onActivate();			
	}
}

function ObserverHUD_MainPane::onActivate( %this )
{
	ObserverHUDGUI.pane = "Main";
}

function ObserverHUD_MainPane::onDeactivate( %this )
{

}

function ObserverHUD_HtmlPane::onActivate( %this )
{
	ObserverHUDGUI.pane = "Html";
}

function ObserverHUD_HtmlPane::onDeactivate( %this )
{

}
function ObserverHUD_FormatPane::onActivate( %this )
{
	ObserverHUDGUI.pane = "Format";
}

function ObserverHUD_FormatPane::onDeactivate( %this )
{

}
function ObserverHUD_ColorPane::onActivate( %this )
{
	ObserverHUDGUI.pane = "Color";
	
	//Hud Colors
	$OHudKillColor = getSubStr( $ObserverHUDSettings::KillColor, 7, 6);
	$OHudDeathColor = getSubStr( $ObserverHUDSettings::DeathColor, 7, 6);
	$OHudStatColor = getSubStr( $ObserverHUDSettings::StatColor, 7, 6);
	$OHudInfoColor = getSubStr( $ObserverHUDSettings::InfoColor, 7, 6);
	$OHudTitleColor = getSubStr( $ObserverHUDSettings::TitleColor, 7, 6);
	
	%this.Update();
}

function ObserverHUD_ColorPane::Update( %this )
{
	ObsHudColorGui_TeamName.settext("<just:center>"@ObserverHUD.titleColor@"Your Team Stats");
	ObsHudColorGui_KillsCount.settext("<just:left>"@ObserverHUD.infoColor@"Kills by Players: <just:right>"@ObserverHUD.StatColor@"15");
	ObsHudColorGui_TurretKillCount.settext("<just:left>"@ObserverHUD.infoColor@"Kills by Turrets: <just:right>"@ObserverHUD.StatColor@"10");
	ObsHudColorGui_TKCount.settext("<just:left>"@ObserverHUD.infoColor@"Team Kills: <just:right>"@ObserverHUD.StatColor@"5");
	ObsHudColorGui_SuicideCount.settext("<just:left>"@ObserverHUD.infoColor@"Suicides: <just:right>"@ObserverHUD.StatColor@"1");
	ObsHudColorGui_DeathCount.settext("<just:left>"@ObserverHUD.infoColor@"Deaths by Players: <just:right>"@ObserverHUD.StatColor@"2");
	ObsHudColorGui_TurretDeathCount.settext("<just:left>"@ObserverHUD.infoColor@"Deaths by Turrets: <just:right>"@ObserverHUD.StatColor@"7");
	ObsHudColorGui_OtherDeathCount.settext("<just:left>"@ObserverHUD.infoColor@"Other Deaths: <just:right>"@ObserverHUD.StatColor@"0");
	ObsHudColorGui_PlayerCount.settext("<just:left>"@ObserverHUD.infoColor@"Num Players: <just:right>"@ObserverHUD.StatColor@"14");
	ObsHudColorGui_PlayerName.settext("<just:center><color:FFFF00>Test_<color:FFFFFF>Player");
	ObsHudColorGui_KillDeath1.settext("<just:left>"@ObserverHUD.infoColor @ "Mortar:<just:right> " @ObserverHUD.KillColor@"10<color:A9D7FA> / " @ ObserverHUD.DeathColor@"8");
	ObsHudColorGui_KillDeath2.settext("<just:left>"@ObserverHUD.infoColor @ "Disc:<just:right> " @ObserverHUD.KillColor@"4<color:A9D7FA> / " @ ObserverHUD.DeathColor@"11");
	ObsHudColorGui_KillDeathtxt.settext("<just:left>"@ObserverHUD.titleColor@"Weapon <just:right>Kills/Deaths");
}

function ObserverHUD_ColorPane::onDeactivate( %this )
{

}

function ObserverHUDGUI::onSleep( %this )
{
   	// Restore the cursor state:
   	if ( !%this.wasCursorOn )
      	CursorOff();

   	ObserverHUD_ColourScheme.clear();

   	$enableDirectInput = "0";
   	deactivateDirectInput();
   	ObserverHUDCreateSettings();
}

function ObserverHUD::OutputTimerAdjust(%this)
{
	%val = ObserverHUD_OutputTimer.getValue();
	%val = mFloor(%val);
	if(%val == 0)
	{
		ObserverHUD_OutputTimerTxt.setValue("Disabled");
		ObserverHUD_SpecificFile.setActive(false);
	}
	else
	{
		ObserverHUD_OutputTimerTxt.setValue(%val @ " sec");
		ObserverHUD_SpecificFile.setActive(true);
	}
}

function ObserverHUD::MaxPlayersAdjust(%this)
{
	%val = ObserverHUD_MaxPlayers.getValue();
	%val = mFloor(%val);
	if(%val == 0)
	{
		ObserverHUD_MaxPlayersTxt.setValue("Unknown");
	}
	else
	{
		ObserverHUD_MaxPlayersTxt.setValue(%val);
	}
}

function ObserverHUD_CSSFileEnabled::onAction(%this)
{
	if($ObserverHUDSettings::UseCssFile)
	{
		$ObserverHUDSettings::UseHtmlFile = false;
		ObserverHUD_CSSFileDisabled.setvalue(0);
	}
	else
	{
		//none
	}
}

function ObserverHUD_CSSFileDisabled::onAction(%this)
{
	if($ObserverHUDSettings::UseHtmlFile)
	{
		$ObserverHUDSettings::UseCssFile = false;
		ObserverHUD_CSSFileEnabled.setvalue(0);
	}
	else
	{
		//none
	}
}

function ObserverHUD_Auto1::onAction( %this )
{
	if($ObserverHUDSettings::AutoViewCarrier)
	{
		$ObserverHUDSettings::Team1AutoViewCarrier = false;
		$ObserverHUDSettings::Team2AutoViewCarrier = false;
		$ObserverHUDSettings::NoAutoView = false;
		ObserverHUD_Auto2.setvalue(0);
		ObserverHUD_Auto3.setvalue(0);
		ObserverHUD_Auto4.setvalue(0);
	}
	else
	{
		$ObserverHUDSettings::NoAutoView = true;
		ObserverHUD_Auto4.setvalue(1);
	}
}

function ObserverHUD_Auto2::onAction( %this )
{
	if($ObserverHUDSettings::Team1AutoViewCarrier)
	{
		$ObserverHUDSettings::AutoViewCarrier = false;
		$ObserverHUDSettings::Team2AutoViewCarrier = false;
		$ObserverHUDSettings::NoAutoView = false;
		ObserverHUD_Auto1.setvalue(0);
		ObserverHUD_Auto3.setvalue(0);
		ObserverHUD_Auto4.setvalue(0);
	}
	else
	{
		$ObserverHUDSettings::NoAutoView = true;
		ObserverHUD_Auto4.setvalue(1);
	}
}

function ObserverHUD_Auto3::onAction( %this )
{
	if($ObserverHUDSettings::Team2AutoViewCarrier)
	{
		$ObserverHUDSettings::AutoViewCarrier = false;
		$ObserverHUDSettings::Team1AutoViewCarrier = false;
		$ObserverHUDSettings::NoAutoView = false;
		ObserverHUD_Auto1.setvalue(0);
		ObserverHUD_Auto2.setvalue(0);
		ObserverHUD_Auto4.setvalue(0);
	}
	else
	{
		$ObserverHUDSettings::NoAutoView = true;
		ObserverHUD_Auto4.setvalue(1);
	}
}

function ObserverHUD_Auto4::onAction( %this )
{
	if($ObserverHUDSettings::NoAutoView)
	{
		$ObserverHUDSettings::AutoViewCarrier = false;
		$ObserverHUDSettings::Team1AutoViewCarrier = false;
		$ObserverHUDSettings::Team2AutoViewCarrier = false;
		ObserverHUD_Auto1.setvalue(0);
		ObserverHUD_Auto2.setvalue(0);
		ObserverHUD_Auto3.setvalue(0);
	}
	else
	{
		$ObserverHUDSettings::AutoViewCarrier = true;
		ObserverHUD_Auto1.setvalue(1);
	}
}

function ObserverHUD_Stats1::onAction( %this )
{
	if($ObserverHUDSettings::NoStatsOutput)
	{
		$ObserverHUDSettings::PromptStatsOutput = false;
		$ObserverHUDSettings::AutoStatsOutput = false;
		ObserverHUD_Stats2.setvalue($ObserverHUDSettings::PromptStatsOutput);
		ObserverHUD_Stats3.setvalue($ObserverHUDSettings::AutoStatsOutput);
	}
	else
	{
		$ObserverHUDSettings::PromptStatsOutput = true;
		ObserverHUD_Stats2.setvalue($ObserverHUDSettings::PromptStatsOutput);
	}
}

function ObserverHUD_Stats2::onAction( %this )
{
	if($ObserverHUDSettings::PromptStatsOutput)
	{
		$ObserverHUDSettings::NoStatsOutput = false;
		$ObserverHUDSettings::AutoStatsOutput = false;
		ObserverHUD_Stats1.setvalue($ObserverHUDSettings::NoStatsOutput);
		ObserverHUD_Stats3.setvalue($ObserverHUDSettings::AutoStatsOutput);
	}
	else
	{
		$ObserverHUDSettings::NoStatsOutput = true;
		ObserverHUD_Stats1.setvalue($ObserverHUDSettings::NoStatsOutput);
	}
}

function ObserverHUD_Stats3::onAction( %this )
{
	if($ObserverHUDSettings::AutoStatsOutput)
	{
		$ObserverHUDSettings::NoStatsOutput = false;
		$ObserverHUDSettings::PromptStatsOutput = false;
		ObserverHUD_Stats1.setvalue($ObserverHUDSettings::NoStatsOutput);
		ObserverHUD_Stats2.setvalue($ObserverHUDSettings::PromptStatsOutput);
	}
	else
	{
		$ObserverHUDSettings::NoStatsOutput = true;
		ObserverHUD_Stats1.setvalue($ObserverHUDSettings::NoStatsOutput);
	}
}

function ObserverHUDDefaultKeys()
{
	observerMap.bind(keyboard, "1", QuickView1);
	observerMap.bind(keyboard, "2", QuickView2);
	observerMap.bind(keyboard, "3", QuickView3);
	observerMap.bind(keyboard, "4", QuickView4);
	observerMap.bind(keyboard, "5", QuickView5);
	observerMap.bind(keyboard, "6", QuickView6);
	observerMap.bind(keyboard, "7", QuickView7);
	observerMap.bind(keyboard, "8", QuickView8);
	observerMap.bind(keyboard, "9", QuickView9);
	observerMap.bind(keyboard, "0", QuickView0);
	observerMap.bind(keyboard, "ctrl 1", SetQuickView1);
	observerMap.bind(keyboard, "ctrl 2", SetQuickView2);
	observerMap.bind(keyboard, "ctrl 3", SetQuickView3);
	observerMap.bind(keyboard, "ctrl 4", SetQuickView4);
	observerMap.bind(keyboard, "ctrl 5", SetQuickView5);
	observerMap.bind(keyboard, "ctrl 6", SetQuickView6);
	observerMap.bind(keyboard, "ctrl 7", SetQuickView7);
	observerMap.bind(keyboard, "ctrl 8", SetQuickView8);
	observerMap.bind(keyboard, "ctrl 9", SetQuickView9);
	observerMap.bind(keyboard, "ctrl 0", SetQuickView0);
	observerMap.bind(keyboard, "q", Team1Flag);
	observerMap.bind(keyboard, "e", Team2Flag);
	observerMap.bind(keyboard, "g", ToggleObserverHUDGameStats);
	observerMap.bind(keyboard, "p", ToggleObserverHUDPlayerStats);
	observerMap.bind(keyboard, "o", ToggleObserverHUD);
	observerMap.bind(keyboard, "q", ToggleObserverHUDQuickView);
	observerMap.bind(keyboard, "n", ToggleObserverHUDTeamStats);
	observerMap.bind(keyboard, "l", ToggleObserverHUDPlayerDetails);
	observerMap.bind(keyboard, "]", Team1Next);
	observerMap.bind(keyboard, "[", Team1Prev);
	observerMap.bind(keyboard, "apostrophe", Team2Next);
	observerMap.bind(keyboard, ";", Team2Prev);
}

function ObserverHUDApplyChanges()
{
	$ObserverHUDSettings::OutputTimer = ObserverHUD_OutputTimer.getValue();
	$ObserverHUDSettings::MaxPlayerLimit = ObserverHUD_MaxPlayers.getValue();

	%temp = ObserverHUD_ColourScheme.getSelected();
	%temp2 = $ObserverHUDSettings::IdtoColourScheme[%temp];
	$ObserverHUDSettings::ColourScheme = %temp2;
	
	if($ObserverHUDSettings::ClanName1 $= "") { $ObserverHUDSettings::ClanName1 = "Team Pub One"; }
	if($ObserverHUDSettings::ClanName2 $= "") { $ObserverHUDSettings::ClanName2 = "Team Pub Two"; }
	
	ObserverHUD.CreateSettings();
	ObserverHUD.ForceOutputCssFile();
}

function ObserverHUD::SetKillColor(%this)
{
	%this.KillColor = "<color:"@$OHudKillColor@">";
	$ObserverHUDSettings::KillColor = %this.KillColor;
	ObserverHUD_ColorPane.Update();
}

function ObserverHUD::SetDeathColor(%this)
{
	%this.DeathColor = "<color:"@$OHudDeathColor@">";
	$ObserverHUDSettings::DeathColor = %this.DeathColor;
	ObserverHUD_ColorPane.Update();
}

function ObserverHUD::SetInfoColor(%this)
{
	%this.InfoColor = "<color:"@$OHudinfoColor@">";
	$ObserverHUDSettings::InfoColor = %this.InfoColor;
	ObserverHUD_ColorPane.Update();
}

function ObserverHUD::SetStatColor(%this)
{
	%this.StatColor = "<color:"@$OHudStatColor@">";
	$ObserverHUDSettings::StatColor = %this.StatColor;
	ObserverHUD_ColorPane.Update();
}

function ObserverHUD::SetTitleColor(%this)
{
	%this.TitleColor = "<color:"@$OHudTitleColor@">";
	$ObserverHUDSettings::TitleColor = %this.TitleColor;
	ObserverHUD_ColorPane.Update();
}