//==================================================================
//==================================================================
//
//                             HUDS
//
//==================================================================
//==================================================================
//==================================================================
//=========================================================================
// TeamStats HUD

new GuiControlProfile ("ObserverHudHdrProfile")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "0 255 255";
	fontColors[6] = $PlayerNameColor;
	fontColors[7] = $TribeTagColor;  
	fontColors[8] = $SmurfNameColor; 
	fontColors[9] = $BotNameColor;   
	autoSizeWidth = false;
	autoSizeHeight = false;
	tab = false;
	canKeyFocus = false;
};


function ObserverHUD::TeamStatsCreate(%this)
{
	%this.TeamStatsDestroy();

	if($ObserverHUDSettings::EnableTeamStats $= "")
		$ObserverHUDSettings::EnableTeamStats = true;
	if(!$ObserverHUDSettings::EnableTeamStats)
		return;

	if(!HudManager.getHud(ObserverHUDTeamStats1).position)
		%ts1position = "8 92";
	else		
		%ts1position = HudManager.getHud(ObserverHUDTeamStats1).position;

	if(!HudManager.getHud(ObserverHUDTeamStats2).position)
		%ts2position = "8 254";
	else		
		%ts2position = HudManager.getHud(ObserverHUDTeamStats2).position;
	
	new ShellFieldCtrl(ObserverHUDTeamStats1)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %ts1position;
		extent = "130 160";

		new GuiMLTextCtrl(ObserverHUDTeamStats1_TeamName)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 4";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats1_KillsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 24";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats1_TurretKillCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 39";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats1_TKCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 54";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats1_SuicideCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 69";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats1_DeathCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 84";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats1_TurretDeathCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 99";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats1_OtherDeathCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 114";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats1_PlayerCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 129";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
	};

	new ShellFieldCtrl(ObserverHUDTeamStats2)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %ts2position;
		extent = "130 160";

		new GuiMLTextCtrl(ObserverHUDTeamStats2_TeamName)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 4";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats2_KillsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 24";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats2_TurretKillCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 39";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats2_TKCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 54";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats2_SuicideCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 69";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats2_DeathCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 84";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats2_TurretDeathCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 99";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats2_OtherDeathCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 114";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDTeamStats2_PlayerCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 129";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
	};
	playGui.add(ObserverHUDTeamStats1);
	playGui.add(ObserverHUDTeamStats2);

	if(isObject(HM) && isObject(HudMover))
	{
		hudmover::addhud(ObserverHUDTeamStats1,"ObserverHUD Team1 Stats");
		hudmover::addhud(ObserverHUDTeamStats2,"ObserverHUD Team2 Stats");
	}

	ObserverHUD.TeamStatsUpdate();
}

function ObserverHUD::TeamStatsUpdate(%this)
{
	%clientname = PlayerList.getMyName();
	if(PlayerList.getTeamByName(%clientname) != 0)
		return;

	if (!isObject(ObserverHUDTeamStats1) || !isObject(ObserverHUDTeamStats2))
	{
		ObserverHUD.TeamStatsCreate();
	}

	if(!$ObserverHUDSettings::EnableTeamStats)
		return;

	//init all stats
	for(%team=1; %team < 3; %team++)
	{
		ObserverHUDMissionData.TeamKill[%team] = ObserverHUDMissionData.TeamKill[%team] $= "" ? 0 : ObserverHUDMissionData.TeamKill[%team];
		ObserverHUDMissionData.TeamTurretKill[%team] = ObserverHUDMissionData.TeamTurretKill[%team] $= "" ? 0 : ObserverHUDMissionData.TeamTurretKill[%team];
		ObserverHUDMissionData.TeamTeamKill[%team] = ObserverHUDMissionData.TeamTeamKill[%team] $= "" ? 0 : ObserverHUDMissionData.TeamTeamKill[%team];
		ObserverHUDMissionData.TeamSuicide[%team] = ObserverHUDMissionData.TeamSuicide[%team] $= "" ? 0 : ObserverHUDMissionData.TeamSuicide[%team];
		ObserverHUDMissionData.TeamDeath[%team] = ObserverHUDMissionData.TeamDeath[%team] $= "" ? 0 : ObserverHUDMissionData.TeamDeath[%team];
		ObserverHUDMissionData.TeamTurretDeath[%team] = ObserverHUDMissionData.TeamTurretDeath[%team] $= "" ? 0 : ObserverHUDMissionData.TeamTurretDeath[%team];
		ObserverHUDMissionData.TeamOtherDeath[%team] = ObserverHUDMissionData.TeamOtherDeath[%team] $= "" ? 0 : ObserverHUDMissionData.TeamOtherDeath[%team];
		ObserverHUDMissionData.TeamPlayers[%team] = ObserverHUDMissionData.TeamPlayers[%team] $= "" ? 0 : ObserverHUDMissionData.TeamPlayers[%team];
	}

	//update Team 1 Stats
	ObserverHUDTeamStats1_TeamName.settext("<just:center>"@%this.titleColor@$clTeamScore[1, 0] SPC "Stats");
	ObserverHUDTeamStats1_KillsCount.settext("<just:left>"@%this.infoColor@"Kills by Players: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamKill[1]);
	ObserverHUDTeamStats1_TurretKillCount.settext("<just:left>"@%this.infoColor@"Kills by Turrets: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamTurretKill[1]);
	ObserverHUDTeamStats1_TKCount.settext("<just:left>"@%this.infoColor@"Team Kills: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamTeamKill[1]);
	ObserverHUDTeamStats1_SuicideCount.settext("<just:left>"@%this.infoColor@"Suicides: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamSuicide[1]);
	ObserverHUDTeamStats1_DeathCount.settext("<just:left>"@%this.infoColor@"Deaths by Players: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamDeath[1]);
	ObserverHUDTeamStats1_TurretDeathCount.settext("<just:left>"@%this.infoColor@"Deaths by Turrets: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamTurretDeath[1]);
	ObserverHUDTeamStats1_OtherDeathCount.settext("<just:left>"@%this.infoColor@"Other Deaths: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamOtherDeath[1]);
	ObserverHUDTeamStats1_PlayerCount.settext("<just:left>"@%this.infoColor@"Num Players: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamPlayers[1]);
	//update Team 2 Stats
	ObserverHUDTeamStats2_TeamName.settext("<just:center>"@%this.titleColor@$clTeamScore[2, 0] SPC "Stats");
	ObserverHUDTeamStats2_KillsCount.settext("<just:left>"@%this.infoColor@"Kills by Players: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamKill[2]);
	ObserverHUDTeamStats2_TurretKillCount.settext("<just:left>"@%this.infoColor@"Kills by Turrets: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamTurretKill[2]);
	ObserverHUDTeamStats2_TKCount.settext("<just:left>"@%this.infoColor@"Team Kills: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamTeamKill[2]);
	ObserverHUDTeamStats2_SuicideCount.settext("<just:left>"@%this.infoColor@"Suicides: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamSuicide[2]);
	ObserverHUDTeamStats2_DeathCount.settext("<just:left>"@%this.infoColor@"Deaths by Players: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamDeath[2]);
	ObserverHUDTeamStats2_TurretDeathCount.settext("<just:left>"@%this.infoColor@"Deaths by Turrets: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamTurretDeath[2]);
	ObserverHUDTeamStats2_OtherDeathCount.settext("<just:left>"@%this.infoColor@"Other Deaths: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamOtherDeath[2]);
	ObserverHUDTeamStats2_PlayerCount.settext("<just:left>"@%this.infoColor@"Num Players: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamPlayers[2]);
}

function ObserverHUD::TeamStatsDestroy(%this)
{
	if (isObject(ObserverHUDTeamStats1))
	{
		playGui.remove(ObserverHUDTeamStats1);
		ObserverHUDTeamStats1.delete();
	}
	if (isObject(ObserverHUDTeamStats2))
	{
		playGui.remove(ObserverHUDTeamStats2);
		ObserverHUDTeamStats2.delete();
	}
}


//=========================================================================
// GameType HUD

function ObserverHUD::GameTypeCreate(%this)
{
	ObserverHUD.GameTypeDestroy();

	if($ObserverHUDSettings::EnableGameType $= "")
		$ObserverHUDSettings::EnableGameType = true;
	if(!$ObserverHUDSettings::EnableGameType)
		return;

	if(!HudManager.getHud(ObserverHUDGameTypeCTF1).position)
		%ctf1position = "885 88";
	else		
		%ctf1position = HudManager.getHud(ObserverHUDGameTypeCTF1).position;

	if(!HudManager.getHud(ObserverHUDGameTypeCTF2).position)
		%ctf2position = "885 174";
	else		
		%ctf2position = HudManager.getHud(ObserverHUDGameTypeCTF2).position;
		
	if(!HudManager.getHud(ObserverHUDGameTypeCNH).position)
		%cnhposition = "885 88";
	else		
		%cnhposition = HudManager.getHud(ObserverHUDGameTypeCNH).position;		

	new ShellFieldCtrl(ObserverHUDGameTypeCTF1)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %ctf1position;
		extent = "130 85";

		new GuiMLTextCtrl(ObserverHUDGameTypeCTF1_TeamName)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 4";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDGameTypeCTF1_CapsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 24";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDGameTypeCTF1_GrabsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 39";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDGameTypeCTF1_DropsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 54";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDGameTypeCTF1_ReturnsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 69";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
	};

   new ShellFieldCtrl(ObserverHUDGameTypeCTF2)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %ctf2position;
		extent = "130 85";

		new GuiMLTextCtrl(ObserverHUDGameTypeCTF2_TeamName)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 4";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDGameTypeCTF2_CapsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 24";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDGameTypeCTF2_GrabsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 39";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDGameTypeCTF2_DropsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 54";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDGameTypeCTF2_ReturnsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 69";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
	};

	new ShellFieldCtrl(ObserverHUDGameTypeCNH)
	{
		profile = "GuiChatBackProfile";
		position = %cnhposition;
		horizSizing = "right";
		vertSizing = "bottom";
		extent = "130 55";

		new GuiMLTextCtrl(ObserverHUDGameTypeCNH_Name)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 4";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDGameTypeCNH_Team1Grab)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 24";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDGameTypeCNH_Team2Grab)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 39";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
	};

	if(ObserverHUDMissionData.GameType $= "CTF")
	{
		playGui.add(ObserverHUDGameTypeCTF1);
		playGui.add(ObserverHUDGameTypeCTF2);
		if(isObject(HM) && isObject(HudMover))
		{
			hudmover::addhud(ObserverHUDGameTypeCTF1,"ObserverHUD CTF Stats1");
			hudmover::addhud(ObserverHUDGameTypeCTF2,"ObserverHUD CTF Stats2");
		}
	}
	else if(ObserverHUDMissionData.GameType $= "CnH")
	{
		playGui.add(ObserverHUDGameTypeCNH);
		if(isObject(HM) && isObject(HudMover))
		{
			hudmover::addhud(ObserverHUDGameTypeCNH,"ObserverHUD CNH Stats");
		}
	}
	else
		return;

	ObserverHUD.GameTypeUpdate();
}

function ObserverHUD::GameTypeUpdate(%this)
{
	%clientname = PlayerList.getMyName();
	if(PlayerList.getTeamByName(%clientname) != 0)
		return;

	if(ObserverHUDMissionData.GameType $= "CTF")
	{
		if (!isObject(ObserverHUDGameTypeCTF1) || !isObject(ObserverHUDGameTypeCTF2))
		{
			ObserverHUD.GameTypeCreate();
		}

		if(!$ObserverHUDSettings::EnableGameType)
			return;

		//init all stats
		for(%team=1; %team < 3; %team++)
		{
			ObserverHUDMissionData.TeamFlagCap[%team] = ObserverHUDMissionData.TeamFlagCap[%team] $= "" ? 0 : ObserverHUDMissionData.TeamFlagCap[%team];
			ObserverHUDMissionData.TeamFlagGrab[%team] = ObserverHUDMissionData.TeamFlagGrab[%team] $= "" ? 0 : ObserverHUDMissionData.TeamFlagGrab[%team];
			ObserverHUDMissionData.TeamFlagDrop[%team] = ObserverHUDMissionData.TeamFlagDrop[%team] $= "" ? 0 : ObserverHUDMissionData.TeamFlagDrop[%team];
			ObserverHUDMissionData.TeamFlagReturn[%team] = ObserverHUDMissionData.TeamFlagReturn[%team] $= "" ? 0 : ObserverHUDMissionData.TeamFlagReturn[%team];
		}

		//update Team 1 Stats
		ObserverHUDGameTypeCTF1_TeamName.settext("<just:center>"@%this.titleColor@$clTeamScore[1, 0] SPC "CTF Stats");
		ObserverHUDGameTypeCTF1_CapsCount.settext("<just:left>"@%this.infoColor@"Caps: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamFlagCap[1]);
		ObserverHUDGameTypeCTF1_GrabsCount.settext("<just:left>"@%this.infoColor@"Grabs/Pickup: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamFlagGrab[1]);
		ObserverHUDGameTypeCTF1_DropsCount.settext("<just:left>"@%this.infoColor@"Drops: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamFlagDrop[1]);
		ObserverHUDGameTypeCTF1_ReturnsCount.settext("<just:left>"@%this.infoColor@"Returns: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamFlagReturn[1]);
		//update Team 2 Stats
		ObserverHUDGameTypeCTF2_TeamName.settext("<just:center>"@%this.titleColor@$clTeamScore[2, 0] SPC "CTF Stats");
		ObserverHUDGameTypeCTF2_CapsCount.settext("<just:left>"@%this.infoColor@"Caps: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamFlagCap[2]);
		ObserverHUDGameTypeCTF2_GrabsCount.settext("<just:left>"@%this.infoColor@"Grabs/Pickup: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamFlagGrab[2]);
		ObserverHUDGameTypeCTF2_DropsCount.settext("<just:left>"@%this.infoColor@"Drops: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamFlagDrop[2]);
		ObserverHUDGameTypeCTF2_ReturnsCount.settext("<just:left>"@%this.infoColor@"Returns: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.TeamFlagReturn[2]);
	}
	else if(ObserverHUDMissionData.GameType $= "CnH")
	{
		if (!isObject(ObserverHUDGameTypeCnH))
		{
			ObserverHUD.GameTypeCreate();
		}

		if(!$ObserverHUDSettings::EnableGameType)
			return;

		//init objective list.
		for(%i=1; %i <= ObserverHUDMissionData.TotalFlipFlops; %i++)
		{
			ObserverHUDMissionData.FFIDtoName[%i] = ObserverHUDMissionData.FFIDtoName[%i] $= "" ? "Obj "@%i : ObserverHUDMissionData.FFIDtoName[%i];
			%name = ObserverHUDMissionData.FFIDtoName[%i];
			ObserverHUDMissionData.Objectives[%name] = ObserverHUDMissionData.Objectives[%name] $= "" ? "None" : ObserverHUDMissionData.Objectives[%name];
		}

		//Update Team Stats
		ObserverHUDGameTypeCNH_Name.settext("<just:center>CnH Game Stats");
		ObserverHUDGameTypeCNH_Team1Grab.settext("<just:left>" @ %this.titleColor @ $clTeamScore[1, 0] @ " Grabs: <just:right>" @ %this.infoColor SPC ObserverHUDMissionData.TeamGrab[1]);
		ObserverHUDGameTypeCNH_Team2Grab.settext("<just:left>" @ %this.titleColor @ $clTeamScore[2, 0] @ " Grabs: <just:right>" @ %this.infoColor SPC ObserverHUDMissionData.TeamGrab[2]);
	}
	else
	{
		ObserverHUD.GameTypeDestroy();
		return;
	}


}

function ObserverHUD::GameTypeDestroy(%this)
{
	if (isObject(ObserverHUDGameTypeCTF1))
	{
		playGui.remove(ObserverHUDGameTypeCTF1);
		ObserverHUDGameTypeCTF1.delete();
	}
	if (isObject(ObserverHUDGameTypeCTF2))
	{
		playGui.remove(ObserverHUDGameTypeCTF2);
		ObserverHUDGameTypeCTF2.delete();
	}
	if (isObject(ObserverHUDGameTypeCNH))
	{
		playGui.remove(ObserverHUDGameTypeCNH);
		ObserverHUDGameTypeCNH.delete();
	}
}


//=========================================================================
// Player Stats HUD

function ObserverHUD::PlayerCreate(%this)
{
	ObserverHUD.PlayerDestroy();

	if($ObserverHUDSettings::EnablePlayerStats $= "")
		$ObserverHUDSettings::EnablePlayerStats = true;
	if(!$ObserverHUDSettings::EnablePlayerStats)
		return;

	if(!HudManager.getHud(ObserverHUDPlayer).position)
		%position = "8 415";
	else		
		%position = HudManager.getHud(ObserverHUDPlayer).position;


	new ShellFieldCtrl(ObserverHUDPlayer)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %position;
		extent = "130 240";

		new GuiMLTextCtrl(ObserverHUDPlayer_Name)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 4";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
			allowcolorchars = 1;
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_PingPL)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 25";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_Score)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 40";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_CapsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 60";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_GrabsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 75";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_DropsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 90";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_ReturnsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 105";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_ObjGrabCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 120";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_KillsCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 135";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_TKCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 150";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_SuicideCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 165";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_DeathCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 180";
			extent = "118 145";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_TurretDeathCount)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 195";
			extent = "118 160";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_LastKilledBy)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 225";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
			allowcolorchars = 1;
		};
		new GuiMLTextCtrl(ObserverHUDPlayer_TeamName)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 210";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
	};

	playGui.add(ObserverHUDPlayer);
	if(isObject(HM) && isObject(HudMover))
	{
		hudmover::addhud(ObserverHUDPlayer,"ObserverHUD Player Stats");
	}

	ObserverHUD.PlayerUpdate();
}

function ObserverHUD::PlayerUpdate(%this)
{
	%clientname = $ObsHUd::clientName;
	if(PlayerList.getTeamByName(%clientname) != 0)
		return;

	if(ObserverHUD.CurrentName $= "")
	{
		ObserverHUD.PlayerDestroy();
		return;
	}

	if (!isObject(ObserverHUDPlayer))
	{
		ObserverHUD.PlayerCreate();
	}

	if(!$ObserverHUDSettings::EnablePlayerStats)
		return;

	//init all stats
	%strippedname = ObserverHUD.CurrentName;
	%clientid = PlayerList.getIDByName(%strippedname);
	%name = PlayerList.getNameByID(%clientId);

	ObserverHUDMissionData.ClientPing[%name] = ObserverHUDMissionData.ClientPing[%name] $= "" ? "NA" : ObserverHUDMissionData.ClientPing[%name];
	ObserverHUDMissionData.ClientPL[%name] = ObserverHUDMissionData.ClientPL[%name] $= "" ? "NA" : ObserverHUDMissionData.ClientPL[%name];
	ObserverHUDMissionData.ClientFlagCap[%name] = ObserverHUDMissionData.ClientFlagCap[%name] $= "" ? 0 : ObserverHUDMissionData.ClientFlagCap[%name];
	ObserverHUDMissionData.ClientFlagGrab[%name] = ObserverHUDMissionData.ClientFlagGrab[%name] $= "" ? 0 : ObserverHUDMissionData.ClientFlagGrab[%name];
	ObserverHUDMissionData.ClientFlagDrop[%name] = ObserverHUDMissionData.ClientFlagDrop[%name] $= "" ? 0 : ObserverHUDMissionData.ClientFlagDrop[%name];
	ObserverHUDMissionData.ClientFlagReturn[%name] = ObserverHUDMissionData.ClientFlagReturn[%name] $= "" ? 0 : ObserverHUDMissionData.ClientFlagReturn[%name];
	ObserverHUDMissionData.ClientGrab[%name] = ObserverHUDMissionData.ClientGrab[%name] $= "" ? 0 : ObserverHUDMissionData.ClientGrab[%name];
	ObserverHUDMissionData.ClientKill[%name] = ObserverHUDMissionData.ClientKill[%name] $= "" ? 0 : ObserverHUDMissionData.ClientKill[%name];
	ObserverHUDMissionData.ClientTeamKill[%name] = ObserverHUDMissionData.ClientTeamKill[%name] $= "" ? 0 : ObserverHUDMissionData.ClientTeamKill[%name];
	ObserverHUDMissionData.ClientSuicide[%name] = ObserverHUDMissionData.ClientSuicide[%name] $= "" ? 0 : ObserverHUDMissionData.ClientSuicide[%name];
	ObserverHUDMissionData.ClientDeath[%name] = ObserverHUDMissionData.ClientDeath[%name] $= "" ? 0 : ObserverHUDMissionData.ClientDeath[%name];
	ObserverHUDMissionData.ClientTurretDeath[%name] = ObserverHUDMissionData.ClientTurretDeath[%name] $= "" ? 0 : ObserverHUDMissionData.ClientTurretDeath[%name];
	ObserverHUDMissionData.ClientDeathBy[%name] = ObserverHUDMissionData.ClientDeathBy[%name] $= "" ? "N/A" : ObserverHUDMissionData.ClientDeathBy[%name];
	%teamid = PlayerList.getTeamByName(%name);
	%teamname = ObserverHUDMissionData.TeamIDtoName[%teamid];

	//update Player Stats
	%score = PlayerList.getScoreByName(%name);
	ObserverHUDPlayer_Name.settext("<just:center>" SPC %name);
	ObserverHUDPlayer_PingPL.settext("<just:left>"@%this.infoColor@"Ping/PL: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientPing[%name] SPC "/" SPC ObserverHUDMissionData.ClientPL[%name]);
	ObserverHUDPlayer_Score.settext("<just:left>"@%this.infoColor@"Score: <just:right>"@%this.StatColor SPC %score);
	ObserverHUDPlayer_CapsCount.settext("<just:left>"@%this.infoColor@"Caps: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientFlagCap[%name]);
	ObserverHUDPlayer_GrabsCount.settext("<just:left>"@%this.infoColor@"Grabs/Pickup: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientFlagGrab[%name]);
	ObserverHUDPlayer_DropsCount.settext("<just:left>"@%this.infoColor@"Drops: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientFlagDrop[%name]);
	ObserverHUDPlayer_ReturnsCount.settext("<just:left>"@%this.infoColor@"Returns: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientFlagReturn[%name]);
	ObserverHUDPlayer_ObjGrabCount.settext("<just:left>"@%this.infoColor@"Flip/Flop Grabs: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientGrab[%name]);
	ObserverHUDPlayer_KillsCount.settext("<just:left>"@%this.infoColor@"Kills: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientKill[%name]);
	ObserverHUDPlayer_TKCount.settext("<just:left>"@%this.infoColor@"Team Kills: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientTeamKill[%name]);
	ObserverHUDPlayer_SuicideCount.settext("<just:left>"@%this.infoColor@"Suicides: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientSuicide[%name]);
	ObserverHUDPlayer_DeathCount.settext("<just:left>"@%this.infoColor@"Deaths: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientDeath[%name]);
	ObserverHUDPlayer_TurretDeathCount.settext("<just:left>"@%this.infoColor@"Deaths by Turrets: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientTurretDeath[%name]);
	ObserverHUDPlayer_LastKilledBy.settext("<just:left>"@%this.infoColor@"Killer: <just:right>"@%this.StatColor SPC ObserverHUDMissionData.ClientDeathBy[%name]);
	ObserverHUDPlayer_TeamName.settext("<just:left>"@%this.infoColor@"Team: <just:right>"@%this.StatColor SPC %teamname);
	
}

function ObserverHUD::PlayerDestroy(%this)
{
	if (isObject(ObserverHUDPlayer))
	{
		playGui.remove(ObserverHUDPlayer);
		ObserverHUDPlayer.delete();
	}
}

//=======================================================================
// Quick View HUD

function ObserverHUD::QuickViewCreate(%this)
{
	ObserverHUD.QuickViewDestroy();

	if($ObserverHUDSettings::EnableQuickView $= "")
		$ObserverHUDSettings::EnableQuickView = true;
	if(!$ObserverHUDSettings::EnableQuickView)
		return;

	if(!HudManager.getHud(ObserverHUDQuickView).position)
		%position = "140 92";
	else		
		%position = HudManager.getHud(ObserverHUDQuickView).position;
	
	new ShellFieldCtrl(ObserverHUDQuickView)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %position;
		extent = "130 210";

		new GuiMLTextCtrl(ObserverHUDQuickView_Title)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 4";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_1)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 25";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_2)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 40";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_3)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 55";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_4)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 70";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_5)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 85";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_6)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 100";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_7)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 115";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_8)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 130";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_9)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 145";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_0)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 160";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_Team1FlagHolder)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 175";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDQuickView_Team2FlagHolder)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 190";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};

	};

	playGui.add(ObserverHUDQuickView);
	if(isObject(HM) && isObject(HudMover))
	{
		hudmover::addhud(ObserverHUDQuickView,"ObserverHUD Quick ViewList");
	}

	ObserverHUD.QuickViewUpdate();
}

function ObserverHUD::QuickViewUpdate(%this)
{
	%clientname = $ObsHUd::clientName;
	if(PlayerList.getTeamByName(%clientname) != 0)
		return;

	if (!isObject(ObserverHUDQuickView))
	{
		ObserverHUD.QuickViewCreate();
	}

	if(!$ObserverHUDSettings::EnableQuickView)
		return;

	for(%i=0; %i<10; %i++)
	{
		%id = %this.QuickListPlayer[%i];
		%namedata[%i] = PlayerList.getNameByID(%id) !$= $PLAYER_ERROR ? PlayerList.getNameByID(%id) : "";
	}
	
	//update List Data
	ObserverHUDQuickView_Title.settext("<just:center>"@%this.titleColor@"Quick View");
	ObserverHUDQuickView_1.settext("<just:left><spush>"@%this.infoColor@"1:<spop>"@%this.statColor SPC %namedata[1]);
	ObserverHUDQuickView_2.settext("<just:left><spush>"@%this.infoColor@"2:<spop>"@%this.statColor SPC %namedata[2]);
	ObserverHUDQuickView_3.settext("<just:left><spush>"@%this.infoColor@"3:<spop>"@%this.statColor SPC %namedata[3]);
	ObserverHUDQuickView_4.settext("<just:left><spush>"@%this.infoColor@"4:<spop>"@%this.statColor SPC %namedata[4]);
	ObserverHUDQuickView_5.settext("<just:left><spush>"@%this.infoColor@"5:<spop>"@%this.statColor SPC %namedata[5]);
	ObserverHUDQuickView_6.settext("<just:left><spush>"@%this.infoColor@"6:<spop>"@%this.statColor SPC %namedata[6]);
	ObserverHUDQuickView_7.settext("<just:left><spush>"@%this.infoColor@"7:<spop>"@%this.statColor SPC %namedata[7]);
	ObserverHUDQuickView_8.settext("<just:left><spush>"@%this.infoColor@"8:<spop>"@%this.statColor SPC %namedata[8]);
	ObserverHUDQuickView_9.settext("<just:left><spush>"@%this.infoColor@"9:<spop>"@%this.statColor SPC %namedata[9]);
	ObserverHUDQuickView_0.settext("<just:left><spush>"@%this.infoColor@"0:<spop>"@%this.statColor SPC %namedata[0]);
	
	%team1_key = observerMap.getBinding( Team1Flag );
	%team2_key = observerMap.getBinding( Team2Flag );
	
	%team1_key = getSubStr(%team1_key, (strlen(%team1_key)-1), 1);
	%team2_key = getSubStr(%team2_key, (strlen(%team2_key)-1), 1);
	
	if ($ObserverHUDFlagStatus[1] $= "") { $ObserverHUDFlagStatus[1] = "At" SPC $clTeamScore[2, 0] SPC "base"; }
	if ($ObserverHUDFlagStatus[2] $= "") { $ObserverHUDFlagStatus[2] = "At" SPC $clTeamScore[1, 0] SPC "base"; }
	
	ObserverHUDQuickView_Team1FlagHolder.settext("<just:left><spush>"@%this.infoColor@%team1_key @ ":<spop>"@%this.statColor@$ObserverHUDFlagStatus[1]);
	ObserverHUDQuickView_Team2FlagHolder.settext("<just:left><spush>"@%this.infoColor@%team2_key @ ":<spop>"@%this.statColor@$ObserverHUDFlagStatus[2]);
}

function ObserverHUD::QuickViewDestroy(%this)
{
	if (isObject(ObserverHUDQuickView))
	{
		playGui.remove(ObserverHUDQuickView);
		ObserverHUDQuickView.delete();
	}
}


//=======================================================================
// Player Detailed HUD

function ObserverHUD::PlayerDetailCreate(%this)
{
	ObserverHUD.PlayerDetailDestroy();

	if($ObserverHUDSettings::EnablePlayerDetail $= "")
		$ObserverHUDSettings::EnablePlayerDetail = false;
	if(!$ObserverHUDSettings::EnablePlayerDetail)
		return;
	
	if(!HudManager.getHud(ObserverHUDPlayerDetail).position)
		%position = "885 261";
	else		
		%position = HudManager.getHud(ObserverHUDPlayerDetail).position;	
	
	%extenty = (ObserverHUDWeaponArray.count * 10) + 45;
	%extent = "130" SPC %extenty;
	
	new ShellFieldCtrl(ObserverHUDPlayerDetail)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %position;
		extent = %extent;

		new GuiMLTextCtrl(ObserverHUDPlayerDetail_Title)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 20";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		new GuiMLTextCtrl(ObserverHUDPlayerDetail_Name)
		{
			profile = "ObserverHudHdrProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 4";
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
			allowcolorchars = 1;
		};

	};

	%nextheight = 35;
	for(%line = 1; %line <= ObserverHUDWeaponArray.count; %line++)
	{

		%name = "ObserverHUDPlayerDetail_"@%line;
		%linepos = "6" SPC %nextheight;
		new GuiMLTextCtrl(%name)
		{
			profile = "GuiAmmoHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = %linepos;
			extent = "118 25";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "";
			maxLength = "255";
		};
		%nextheight += 10;
		ObserverHUDPlayerDetail.add(%name);
	}

	playGui.add(ObserverHUDPlayerDetail);
	if(isObject(HM) && isObject(HudMover))
		hudmover::addhud(ObserverHUDPlayerDetail,"ObserverHUD PlayerDetail List");

	ObserverHUD.PlayerDetailUpdate();
}

function ObserverHUD::PlayerDetailUpdate(%this)
{
	%clientname = PlayerList.getMyName();
	if(PlayerList.getTeamByName(%clientname) != 0)
		return;

	if(%this.CurrentName $= "")
	{
		ObserverHUD.PlayerDetailDestroy();
		return;
	}

	if (!isObject(ObserverHUDPlayerDetail))
	{
		ObserverHUD.PlayerDetailCreate();
	}

	if(!$ObserverHUDSettings::EnablePlayerDetail)
		return;

	//re init list data
	%strippedname = %this.CurrentName;
	%clientid = PlayerList.getIDByName(%strippedname);
	%name = PlayerList.getNameByID(%clientid);
	
	//update List Data
	ObserverHUDPlayerDetail_Title.settext("<just:left>"@%this.titleColor@"Weapon <just:right>Kills/Deaths");
	ObserverHUDPlayerDetail_Name.settext("<just:center>"@%this.CurrentName);
	
	for(%i=1; %i<=ObserverHUDWeaponArray.count; %i++)
	{
		%textname = "ObserverHUDPlayerDetail_"@%i;
		%tracker = "WeaponArrayKillsDeaths[" @ %name @ "]";
		
		%weapon = ObserverHUDWeaponArray.weapon[%i];
		
		%weaponKills = %tracker.kills[%weapon];
		%weaponDeaths = %tracker.deaths[%weapon];

		if (%weaponKills $= "") { %weaponKills = "0"; }
		if (%weaponDeaths $= "") { %weaponDeaths = "0"; }
		
		if(!isObject(%textname))
		{
			ObserverHUD.PlayerDetailCreate();
		} else {
			%textname.settext("<just:left>" @ %this.infoColor @ %weapon @ ":<just:right> " @ %this.KillColor @ %weaponKills @ %this.statColor @ " / " @ %this.DeathColor @ %weaponDeaths);
		}
		
		// %total_kills = %weaponKills+%total_kills;
		// %total_deaths = %weaponDeaths+%total_deaths;
	}
	
	//update List Data
	// ObserverHUDPlayerDetail_Title.settext("<just:center>Player  Kills(" @ %total_kills @ ")/Deaths(" @ %total_deaths @ ")");
}

function ObserverHUD::PlayerDetailDestroy(%this)
{
	if (isObject(ObserverHUDPlayerDetail))
	{
		playGui.remove(ObserverHUDPlayerDetail);
		ObserverHUDPlayerDetail.delete();
	}
}

function ObserverHUD::SetKillColor(%this)
{
	%this.KillColor = "<color:"@$OHudKillColor@">";
	$ObserverHUDSettings::KillColor = %this.KillColor;
	ObserverHUD_ColorPane.Update();
}

function ObserverHUD::SetDeathColor(%this)
{
	%this.DeathColor = "<color:"@$OHudDeathColor@">";
	$ObserverHUDSettings::DeathColor = %this.DeathColor;
	ObserverHUD_ColorPane.Update();
}

function ObserverHUD::SetInfoColor(%this)
{
	%this.InfoColor = "<color:"@$OHudinfoColor@">";
	$ObserverHUDSettings::InfoColor = %this.InfoColor;
	ObserverHUD_ColorPane.Update();
}

function ObserverHUD::SetStatColor(%this)
{
	%this.StatColor = "<color:"@$OHudStatColor@">";
	$ObserverHUDSettings::StatColor = %this.StatColor;
	ObserverHUD_ColorPane.Update();
}

function ObserverHUD::SetTitleColor(%this)
{
	%this.TitleColor = "<color:"@$OHudTitleColor@">";
	$ObserverHUDSettings::TitleColor = %this.TitleColor;
	ObserverHUD_ColorPane.Update();
}

//========================================================================
// ObserverHUD Main HUD Controls

function ObserverHUD::Create(%this)
{
	%this.TeamStatsCreate();
	%this.GameTypeCreate();
	%this.PlayerCreate();
	%this.QuickViewCreate();
	%this.PlayerDetailCreate();
}

function ObserverHUD::Update(%this)
{
	%clientname = PlayerList.getMyName();
	if(PlayerList.getTeamByName(%clientname) != 0)
		return;
	%this.TeamStatsUpdate();
	%this.GameTypeUpdate();
	%this.PlayerUpdate();
	%this.QuickViewUpdate();
	%this.PlayerDetailUpdate();
}

function ObserverHUD::Destroy(%this)
{
	%this.TeamStatsDestroy();
	%this.GameTypeDestroy();
	%this.PlayerDestroy();
	%this.QuickViewDestroy();
	%this.PlayerDetailDestroy();
}
